// simple DAC test program for PIC18F47K42 on EasyPIC8 board
// 8MHz crystal and 4xPLL gives 32 MHz clock
// connect an oscilloscope to RA2 to see the output ramp waveform
// turn off LEDs for PORT A and ensure no other connections to RA2

void main() {
int dac_step;

     DAC1CON0 = 0xa0;                                             // DAC enabled using supply pins as reference

     while(1){
         for(dac_step = 0 ; dac_step < 32 ; dac_step++){          // 32 steps as DAC has 32 possible values
             DAC1CON1 = dac_step;                                 // set the value for DAC
             Delay_us(76);                                        // slow the waveform down from 16kHz to 400Hz
             //Delay_ms(1000);                                    // slow the waveform down to 1 cycle every 32 seconds (for multimeter)
         }
     }
}