
_interrupt:

;MIDImon.c,61 :: 		void interrupt() {                                                              // Interrupt routine
;MIDImon.c,62 :: 		if(U2RXIF_bit) {                                                            // Checks for Receive Interrupt Flag bit
	BTFSS       U2RXIF_bit+0, BitPos(U2RXIF_bit+0) 
	GOTO        L_interrupt0
;MIDImon.c,63 :: 		u2_rx_data = UART2_Read();                                              // Storing read data
	CALL        _UART2_Read+0, 0
	MOVF        R0, 0 
	MOVWF       _u2_rx_data+0 
;MIDImon.c,64 :: 		ByteToHex(u2_rx_data, int_rx_buf);
	MOVF        R0, 0 
	MOVWF       FARG_ByteToHex_input+0 
	MOVLW       _int_rx_buf+0
	MOVWF       FARG_ByteToHex_output+0 
	MOVLW       hi_addr(_int_rx_buf+0)
	MOVWF       FARG_ByteToHex_output+1 
	CALL        _ByteToHex+0, 0
;MIDImon.c,65 :: 		u2_rx_flag = 1;
	MOVLW       1
	MOVWF       _u2_rx_flag+0 
;MIDImon.c,66 :: 		}
L_interrupt0:
;MIDImon.c,67 :: 		}
L_end_interrupt:
L__interrupt95:
	RETFIE      1
; end of _interrupt

_main:

;MIDImon.c,69 :: 		void main() {
;MIDImon.c,70 :: 		rxidx  = 0;                                                                 // Initialisation of variable
	CLRF        _rxidx+0 
;MIDImon.c,71 :: 		ANSELA = 0;                                                                 // Configure PORT pins as digital
	CLRF        ANSELA+0 
;MIDImon.c,72 :: 		ANSELB = 0;                                                                 // Configure PORT pins as digital
	CLRF        ANSELB+0 
;MIDImon.c,73 :: 		ANSELC = 0;                                                                 // Configure PORT pins as digital
	CLRF        ANSELC+0 
;MIDImon.c,74 :: 		ANSELD = 0;                                                                 // Configure PORT pins as digital
	CLRF        ANSELD+0 
;MIDImon.c,75 :: 		TRISA = 0;
	CLRF        TRISA+0 
;MIDImon.c,76 :: 		TRISB  = 0;                                                                 // Configure PORT as output
	CLRF        TRISB+0 
;MIDImon.c,77 :: 		TRISC  = 0;                                                                 // Configure PORT as output
	CLRF        TRISC+0 
;MIDImon.c,78 :: 		TRISD  = 0;                                                                 // Configure PORT as output
	CLRF        TRISD+0 
;MIDImon.c,79 :: 		LATA = 0;
	CLRF        LATA+0 
;MIDImon.c,80 :: 		LATB = 0x00;                                                                // clear all to Low
	CLRF        LATB+0 
;MIDImon.c,81 :: 		LATC = 0x00;                                                                // clear all to Low
	CLRF        LATC+0 
;MIDImon.c,82 :: 		LATD = 0x00;                                                                // clear all to Low
	CLRF        LATD+0 
;MIDImon.c,85 :: 		UART2_Init(31250);                                                          // Initialize UART 2 module for midi
	MOVLW       255
	MOVWF       U2BRG+0 
	MOVLW       0
	MOVWF       U2BRG+1 
	BSF         U2CON0+0, 7, 0
	CALL        _UART2_Init+0, 0
;MIDImon.c,86 :: 		UART1_Init(115200);                                                         // Initialize UART 1 module at least 3x MIDI rate
	MOVLW       68
	MOVWF       U1BRG+0 
	MOVLW       0
	MOVWF       U1BRG+1 
	BSF         U1CON0+0, 7, 0
	CALL        _UART1_Init+0, 0
;MIDImon.c,87 :: 		Delay_ms(100);                                                              // Wait for UART modules to stabilize
	MOVLW       5
	MOVWF       R11, 0
	MOVLW       15
	MOVWF       R12, 0
	MOVLW       241
	MOVWF       R13, 0
L_main1:
	DECFSZ      R13, 1, 1
	BRA         L_main1
	DECFSZ      R12, 1, 1
	BRA         L_main1
	DECFSZ      R11, 1, 1
	BRA         L_main1
;MIDImon.c,88 :: 		newcmd = '?';                                                               // default to help
	MOVLW       63
	MOVWF       _newcmd+0 
;MIDImon.c,89 :: 		cmd = newcmd;
	MOVLW       63
	MOVWF       _cmd+0 
;MIDImon.c,91 :: 		UART1_Write_Text("\r\n\nMIDI Monitor 30 Aug 2019\r\n");                     // introduction text
	MOVLW       ?lstr1_MIDImon+0
	MOVWF       FARG_UART1_Write_Text_uart_text+0 
	MOVLW       hi_addr(?lstr1_MIDImon+0)
	MOVWF       FARG_UART1_Write_Text_uart_text+1 
	CALL        _UART1_Write_Text+0, 0
;MIDImon.c,92 :: 		UART1_Write_Text("MIDI Out RB5, MIDI In RB2 (via interface hardware)\r\n");                                         // introduction text
	MOVLW       ?lstr2_MIDImon+0
	MOVWF       FARG_UART1_Write_Text_uart_text+0 
	MOVLW       hi_addr(?lstr2_MIDImon+0)
	MOVWF       FARG_UART1_Write_Text_uart_text+1 
	CALL        _UART1_Write_Text+0, 0
;MIDImon.c,93 :: 		UART1_Write_Text("? for help\r\n");                                         // introduction text
	MOVLW       ?lstr3_MIDImon+0
	MOVWF       FARG_UART1_Write_Text_uart_text+0 
	MOVLW       hi_addr(?lstr3_MIDImon+0)
	MOVWF       FARG_UART1_Write_Text_uart_text+1 
	CALL        _UART1_Write_Text+0, 0
;MIDImon.c,95 :: 		U2RXIE_bit = 1;                                                             // turn ON interrupt on UART1 receive
	BSF         U2RXIE_bit+0, BitPos(U2RXIE_bit+0) 
;MIDImon.c,96 :: 		U2RXIF_bit = 0;                                                             // Clear interrupt flag
	BCF         U2RXIF_bit+0, BitPos(U2RXIF_bit+0) 
;MIDImon.c,98 :: 		GIE_bit   = 1;                                                              // Enable GLOBAL interrupts
	BSF         GIE_bit+0, BitPos(GIE_bit+0) 
;MIDImon.c,100 :: 		while(1){
L_main2:
;MIDImon.c,101 :: 		linein(linebuff);                                                       // fetch a line of text
	MOVLW       _linebuff+0
	MOVWF       FARG_linein_pstring+0 
	MOVLW       hi_addr(_linebuff+0)
	MOVWF       FARG_linein_pstring+1 
	CALL        _linein+0, 0
;MIDImon.c,102 :: 		newcmd = getparams(linebuff);                                           // read hex parameters
	MOVLW       _linebuff+0
	MOVWF       FARG_getparams_tempstring+0 
	MOVLW       hi_addr(_linebuff+0)
	MOVWF       FARG_getparams_tempstring+1 
	CALL        _getparams+0, 0
	MOVF        R0, 0 
	MOVWF       _newcmd+0 
;MIDImon.c,103 :: 		switch(newcmd){                                                         // find command letter
	GOTO        L_main4
;MIDImon.c,104 :: 		case 'O':
L_main6:
;MIDImon.c,105 :: 		cmdo();
	CALL        _cmdo+0, 0
;MIDImon.c,106 :: 		break;
	GOTO        L_main5
;MIDImon.c,108 :: 		case 'P':
L_main7:
;MIDImon.c,109 :: 		cmdp();
	CALL        _cmdp+0, 0
;MIDImon.c,110 :: 		break;
	GOTO        L_main5
;MIDImon.c,112 :: 		case 'Z':
L_main8:
;MIDImon.c,113 :: 		cmdz();
	CALL        _cmdz+0, 0
;MIDImon.c,114 :: 		break;
	GOTO        L_main5
;MIDImon.c,116 :: 		case '?':
L_main9:
;MIDImon.c,117 :: 		UART1_Write_Text("\r\n?        List Commands");
	MOVLW       ?lstr4_MIDImon+0
	MOVWF       FARG_UART1_Write_Text_uart_text+0 
	MOVLW       hi_addr(?lstr4_MIDImon+0)
	MOVWF       FARG_UART1_Write_Text_uart_text+1 
	CALL        _UART1_Write_Text+0, 0
;MIDImon.c,118 :: 		UART1_Write_Text("\r\no cc ..  Output hex to MIDI");
	MOVLW       ?lstr5_MIDImon+0
	MOVWF       FARG_UART1_Write_Text_uart_text+0 
	MOVLW       hi_addr(?lstr5_MIDImon+0)
	MOVWF       FARG_UART1_Write_Text_uart_text+1 
	CALL        _UART1_Write_Text+0, 0
;MIDImon.c,119 :: 		UART1_Write_Text("\r\np        Parameter test");
	MOVLW       ?lstr6_MIDImon+0
	MOVWF       FARG_UART1_Write_Text_uart_text+0 
	MOVLW       hi_addr(?lstr6_MIDImon+0)
	MOVWF       FARG_UART1_Write_Text_uart_text+1 
	CALL        _UART1_Write_Text+0, 0
;MIDImon.c,120 :: 		UART1_Write_Text("\r\nz        Bassboy send test\r\n");
	MOVLW       ?lstr7_MIDImon+0
	MOVWF       FARG_UART1_Write_Text_uart_text+0 
	MOVLW       hi_addr(?lstr7_MIDImon+0)
	MOVWF       FARG_UART1_Write_Text_uart_text+1 
	CALL        _UART1_Write_Text+0, 0
;MIDImon.c,121 :: 		break;
	GOTO        L_main5
;MIDImon.c,123 :: 		default:{
L_main10:
;MIDImon.c,124 :: 		UART1_Write_Text("\r\ncommand not recognised\r\n");
	MOVLW       ?lstr8_MIDImon+0
	MOVWF       FARG_UART1_Write_Text_uart_text+0 
	MOVLW       hi_addr(?lstr8_MIDImon+0)
	MOVWF       FARG_UART1_Write_Text_uart_text+1 
	CALL        _UART1_Write_Text+0, 0
;MIDImon.c,125 :: 		break;
	GOTO        L_main5
;MIDImon.c,127 :: 		}
L_main4:
	MOVF        _newcmd+0, 0 
	XORLW       79
	BTFSC       STATUS+0, 2 
	GOTO        L_main6
	MOVF        _newcmd+0, 0 
	XORLW       80
	BTFSC       STATUS+0, 2 
	GOTO        L_main7
	MOVF        _newcmd+0, 0 
	XORLW       90
	BTFSC       STATUS+0, 2 
	GOTO        L_main8
	MOVF        _newcmd+0, 0 
	XORLW       63
	BTFSC       STATUS+0, 2 
	GOTO        L_main9
	GOTO        L_main10
L_main5:
;MIDImon.c,128 :: 		}
	GOTO        L_main2
;MIDImon.c,129 :: 		}
L_end_main:
	GOTO        $+0
; end of _main

_cmdo:

;MIDImon.c,134 :: 		void cmdo(){
;MIDImon.c,137 :: 		UART1_Write_Text("MIDI out ");
	MOVLW       ?lstr9_MIDImon+0
	MOVWF       FARG_UART1_Write_Text_uart_text+0 
	MOVLW       hi_addr(?lstr9_MIDImon+0)
	MOVWF       FARG_UART1_Write_Text_uart_text+1 
	CALL        _UART1_Write_Text+0, 0
;MIDImon.c,138 :: 		for(pc = 1; pc < nparams; pc++){
	MOVLW       1
	MOVWF       cmdo_pc_L0+0 
L_cmdo11:
	MOVF        _nparams+0, 0 
	SUBWF       cmdo_pc_L0+0, 0 
	BTFSC       STATUS+0, 0 
	GOTO        L_cmdo12
;MIDImon.c,139 :: 		UART2_Write(upar[pc]);
	MOVF        cmdo_pc_L0+0, 0 
	MOVWF       R0 
	MOVLW       0
	MOVWF       R1 
	RLCF        R0, 1 
	BCF         R0, 0 
	RLCF        R1, 1 
	MOVLW       _upar+0
	ADDWF       R0, 0 
	MOVWF       FSR0L+0 
	MOVLW       hi_addr(_upar+0)
	ADDWFC      R1, 0 
	MOVWF       FSR0L+1 
	MOVF        POSTINC0+0, 0 
	MOVWF       FARG_UART2_Write_data_+0 
	CALL        _UART2_Write+0, 0
;MIDImon.c,140 :: 		PrintHexSp(upar[pc]);
	MOVF        cmdo_pc_L0+0, 0 
	MOVWF       R0 
	MOVLW       0
	MOVWF       R1 
	RLCF        R0, 1 
	BCF         R0, 0 
	RLCF        R1, 1 
	MOVLW       _upar+0
	ADDWF       R0, 0 
	MOVWF       FSR0L+0 
	MOVLW       hi_addr(_upar+0)
	ADDWFC      R1, 0 
	MOVWF       FSR0L+1 
	MOVF        POSTINC0+0, 0 
	MOVWF       FARG_PrintHexSp_i+0 
	CALL        _PrintHexSp+0, 0
;MIDImon.c,138 :: 		for(pc = 1; pc < nparams; pc++){
	INCF        cmdo_pc_L0+0, 1 
;MIDImon.c,141 :: 		}
	GOTO        L_cmdo11
L_cmdo12:
;MIDImon.c,142 :: 		UART1_Write_Text("\r\n");
	MOVLW       ?lstr10_MIDImon+0
	MOVWF       FARG_UART1_Write_Text_uart_text+0 
	MOVLW       hi_addr(?lstr10_MIDImon+0)
	MOVWF       FARG_UART1_Write_Text_uart_text+1 
	CALL        _UART1_Write_Text+0, 0
;MIDImon.c,143 :: 		}
L_end_cmdo:
	RETURN      0
; end of _cmdo

_cmdp:

;MIDImon.c,145 :: 		void cmdp(){
;MIDImon.c,147 :: 		PrintHex(nparams);
	MOVF        _nparams+0, 0 
	MOVWF       FARG_PrintHex_i+0 
	CALL        _PrintHex+0, 0
;MIDImon.c,148 :: 		UART1_Write_Text(" parameters\r\n");
	MOVLW       ?lstr11_MIDImon+0
	MOVWF       FARG_UART1_Write_Text_uart_text+0 
	MOVLW       hi_addr(?lstr11_MIDImon+0)
	MOVWF       FARG_UART1_Write_Text_uart_text+1 
	CALL        _UART1_Write_Text+0, 0
;MIDImon.c,149 :: 		for( paramcount = 0 ; paramcount < 8 ; paramcount++ ){
	CLRF        cmdp_paramcount_L0+0 
L_cmdp14:
	MOVLW       8
	SUBWF       cmdp_paramcount_L0+0, 0 
	BTFSC       STATUS+0, 0 
	GOTO        L_cmdp15
;MIDImon.c,150 :: 		UART1_Write_Text("parameter ");
	MOVLW       ?lstr12_MIDImon+0
	MOVWF       FARG_UART1_Write_Text_uart_text+0 
	MOVLW       hi_addr(?lstr12_MIDImon+0)
	MOVWF       FARG_UART1_Write_Text_uart_text+1 
	CALL        _UART1_Write_Text+0, 0
;MIDImon.c,151 :: 		PrintHexSp(paramcount);
	MOVF        cmdp_paramcount_L0+0, 0 
	MOVWF       FARG_PrintHexSp_i+0 
	CALL        _PrintHexSp+0, 0
;MIDImon.c,152 :: 		PrintHex((upar[paramcount] >> 8) & 0xff);
	MOVF        cmdp_paramcount_L0+0, 0 
	MOVWF       R0 
	MOVLW       0
	MOVWF       R1 
	RLCF        R0, 1 
	BCF         R0, 0 
	RLCF        R1, 1 
	MOVLW       _upar+0
	ADDWF       R0, 0 
	MOVWF       FSR0L+0 
	MOVLW       hi_addr(_upar+0)
	ADDWFC      R1, 0 
	MOVWF       FSR0L+1 
	MOVF        POSTINC0+0, 0 
	MOVWF       R3 
	MOVF        POSTINC0+0, 0 
	MOVWF       R4 
	MOVF        R4, 0 
	MOVWF       R0 
	CLRF        R1 
	MOVLW       255
	ANDWF       R0, 0 
	MOVWF       FARG_PrintHex_i+0 
	CALL        _PrintHex+0, 0
;MIDImon.c,153 :: 		PrintHex((upar[paramcount]) & 0xff);
	MOVF        cmdp_paramcount_L0+0, 0 
	MOVWF       R0 
	MOVLW       0
	MOVWF       R1 
	RLCF        R0, 1 
	BCF         R0, 0 
	RLCF        R1, 1 
	MOVLW       _upar+0
	ADDWF       R0, 0 
	MOVWF       FSR0L+0 
	MOVLW       hi_addr(_upar+0)
	ADDWFC      R1, 0 
	MOVWF       FSR0L+1 
	MOVLW       255
	ANDWF       POSTINC0+0, 0 
	MOVWF       FARG_PrintHex_i+0 
	CALL        _PrintHex+0, 0
;MIDImon.c,154 :: 		UART1_Write_Text("\r\n");
	MOVLW       ?lstr13_MIDImon+0
	MOVWF       FARG_UART1_Write_Text_uart_text+0 
	MOVLW       hi_addr(?lstr13_MIDImon+0)
	MOVWF       FARG_UART1_Write_Text_uart_text+1 
	CALL        _UART1_Write_Text+0, 0
;MIDImon.c,149 :: 		for( paramcount = 0 ; paramcount < 8 ; paramcount++ ){
	INCF        cmdp_paramcount_L0+0, 1 
;MIDImon.c,155 :: 		}
	GOTO        L_cmdp14
L_cmdp15:
;MIDImon.c,156 :: 		}
L_end_cmdp:
	RETURN      0
; end of _cmdp

_cmdz:

;MIDImon.c,177 :: 		void cmdz(){
;MIDImon.c,180 :: 		UART1_Write_Text("\r\nBassBoy MIDI out on RB5\r\n");
	MOVLW       ?lstr14_MIDImon+0
	MOVWF       FARG_UART1_Write_Text_uart_text+0 
	MOVLW       hi_addr(?lstr14_MIDImon+0)
	MOVWF       FARG_UART1_Write_Text_uart_text+1 
	CALL        _UART1_Write_Text+0, 0
;MIDImon.c,181 :: 		for(pc = 0; pc < sizeof(midi_a); pc++){
	CLRF        cmdz_pc_L0+0 
L_cmdz17:
	MOVLW       21
	SUBWF       cmdz_pc_L0+0, 0 
	BTFSC       STATUS+0, 0 
	GOTO        L_cmdz18
;MIDImon.c,182 :: 		UART2_Write(midi_a[pc]);
	MOVLW       _midi_a+0
	MOVWF       FSR0L+0 
	MOVLW       hi_addr(_midi_a+0)
	MOVWF       FSR0L+1 
	MOVF        cmdz_pc_L0+0, 0 
	ADDWF       FSR0L+0, 1 
	BTFSC       STATUS+0, 0 
	INCF        FSR0L+1, 1 
	MOVF        POSTINC0+0, 0 
	MOVWF       FARG_UART2_Write_data_+0 
	CALL        _UART2_Write+0, 0
;MIDImon.c,183 :: 		if(midi_a[pc] > 127){                            // control byte
	MOVLW       _midi_a+0
	MOVWF       FSR0L+0 
	MOVLW       hi_addr(_midi_a+0)
	MOVWF       FSR0L+1 
	MOVF        cmdz_pc_L0+0, 0 
	ADDWF       FSR0L+0, 1 
	BTFSC       STATUS+0, 0 
	INCF        FSR0L+1, 1 
	MOVF        POSTINC0+0, 0 
	SUBLW       127
	BTFSC       STATUS+0, 0 
	GOTO        L_cmdz20
;MIDImon.c,184 :: 		Delay_ms(1000);
	MOVLW       41
	MOVWF       R11, 0
	MOVLW       150
	MOVWF       R12, 0
	MOVLW       127
	MOVWF       R13, 0
L_cmdz21:
	DECFSZ      R13, 1, 1
	BRA         L_cmdz21
	DECFSZ      R12, 1, 1
	BRA         L_cmdz21
	DECFSZ      R11, 1, 1
	BRA         L_cmdz21
;MIDImon.c,185 :: 		UART1_Write_Text("\r\n");
	MOVLW       ?lstr15_MIDImon+0
	MOVWF       FARG_UART1_Write_Text_uart_text+0 
	MOVLW       hi_addr(?lstr15_MIDImon+0)
	MOVWF       FARG_UART1_Write_Text_uart_text+1 
	CALL        _UART1_Write_Text+0, 0
;MIDImon.c,186 :: 		}
L_cmdz20:
;MIDImon.c,187 :: 		PrintHexSp(midi_a[pc]);
	MOVLW       _midi_a+0
	MOVWF       FSR0L+0 
	MOVLW       hi_addr(_midi_a+0)
	MOVWF       FSR0L+1 
	MOVF        cmdz_pc_L0+0, 0 
	ADDWF       FSR0L+0, 1 
	BTFSC       STATUS+0, 0 
	INCF        FSR0L+1, 1 
	MOVF        POSTINC0+0, 0 
	MOVWF       FARG_PrintHexSp_i+0 
	CALL        _PrintHexSp+0, 0
;MIDImon.c,181 :: 		for(pc = 0; pc < sizeof(midi_a); pc++){
	INCF        cmdz_pc_L0+0, 1 
;MIDImon.c,189 :: 		}
	GOTO        L_cmdz17
L_cmdz18:
;MIDImon.c,190 :: 		midi_off();
	CALL        _midi_off+0, 0
;MIDImon.c,191 :: 		UART1_Write_Text("\r\n");
	MOVLW       ?lstr16_MIDImon+0
	MOVWF       FARG_UART1_Write_Text_uart_text+0 
	MOVLW       hi_addr(?lstr16_MIDImon+0)
	MOVWF       FARG_UART1_Write_Text_uart_text+1 
	CALL        _UART1_Write_Text+0, 0
;MIDImon.c,192 :: 		}
L_end_cmdz:
	RETURN      0
; end of _cmdz

_midi_off:

;MIDImon.c,195 :: 		void midi_off(){
;MIDImon.c,196 :: 		Delay_ms(2000);                                     // allow time to hear final note
	MOVLW       82
	MOVWF       R11, 0
	MOVLW       43
	MOVWF       R12, 0
	MOVLW       0
	MOVWF       R13, 0
L_midi_off22:
	DECFSZ      R13, 1, 1
	BRA         L_midi_off22
	DECFSZ      R12, 1, 1
	BRA         L_midi_off22
	DECFSZ      R11, 1, 1
	BRA         L_midi_off22
	NOP
;MIDImon.c,197 :: 		UART1_Write_Text("\r\nB0 7B 00 (all notes off)\r\n");
	MOVLW       ?lstr17_MIDImon+0
	MOVWF       FARG_UART1_Write_Text_uart_text+0 
	MOVLW       hi_addr(?lstr17_MIDImon+0)
	MOVWF       FARG_UART1_Write_Text_uart_text+1 
	CALL        _UART1_Write_Text+0, 0
;MIDImon.c,198 :: 		UART2_Write(0xb0);
	MOVLW       176
	MOVWF       FARG_UART2_Write_data_+0 
	CALL        _UART2_Write+0, 0
;MIDImon.c,199 :: 		UART2_Write(0x7b);
	MOVLW       123
	MOVWF       FARG_UART2_Write_data_+0 
	CALL        _UART2_Write+0, 0
;MIDImon.c,200 :: 		UART2_Write(0x00);
	CLRF        FARG_UART2_Write_data_+0 
	CALL        _UART2_Write+0, 0
;MIDImon.c,201 :: 		UART1_Write_Text("\r\ndone...\r\n");
	MOVLW       ?lstr18_MIDImon+0
	MOVWF       FARG_UART1_Write_Text_uart_text+0 
	MOVLW       hi_addr(?lstr18_MIDImon+0)
	MOVWF       FARG_UART1_Write_Text_uart_text+1 
	CALL        _UART1_Write_Text+0, 0
;MIDImon.c,202 :: 		}
L_end_midi_off:
	RETURN      0
; end of _midi_off

_PrintHex:

;MIDImon.c,205 :: 		void PrintHex(unsigned char i) {
;MIDImon.c,208 :: 		hi = i & 0xF0;                                                              // high nibble
	MOVLW       240
	ANDWF       FARG_PrintHex_i+0, 0 
	MOVWF       R2 
	MOVF        R2, 0 
	MOVWF       PrintHex_hi_L0+0 
;MIDImon.c,209 :: 		hi = hi >> 4;
	MOVF        R2, 0 
	MOVWF       R0 
	RRCF        R0, 1 
	BCF         R0, 7 
	RRCF        R0, 1 
	BCF         R0, 7 
	RRCF        R0, 1 
	BCF         R0, 7 
	RRCF        R0, 1 
	BCF         R0, 7 
	MOVF        R0, 0 
	MOVWF       PrintHex_hi_L0+0 
;MIDImon.c,210 :: 		hi = hi + '0';
	MOVLW       48
	ADDWF       R0, 0 
	MOVWF       R1 
	MOVF        R1, 0 
	MOVWF       PrintHex_hi_L0+0 
;MIDImon.c,211 :: 		if (hi > '9') hi = hi + 7;
	MOVF        R1, 0 
	SUBLW       57
	BTFSC       STATUS+0, 0 
	GOTO        L_PrintHex23
	MOVLW       7
	ADDWF       PrintHex_hi_L0+0, 1 
L_PrintHex23:
;MIDImon.c,212 :: 		lo = (i & 0x0F) + '0';                                                      // low nibble
	MOVLW       15
	ANDWF       FARG_PrintHex_i+0, 0 
	MOVWF       R0 
	MOVLW       48
	ADDWF       R0, 0 
	MOVWF       R1 
	MOVF        R1, 0 
	MOVWF       PrintHex_lo_L0+0 
;MIDImon.c,213 :: 		if (lo>'9') lo=lo+7;
	MOVF        R1, 0 
	SUBLW       57
	BTFSC       STATUS+0, 0 
	GOTO        L_PrintHex24
	MOVLW       7
	ADDWF       PrintHex_lo_L0+0, 1 
L_PrintHex24:
;MIDImon.c,215 :: 		UART1_Write(hi);
	MOVF        PrintHex_hi_L0+0, 0 
	MOVWF       FARG_UART1_Write_data_+0 
	CALL        _UART1_Write+0, 0
;MIDImon.c,216 :: 		UART1_Write(lo);
	MOVF        PrintHex_lo_L0+0, 0 
	MOVWF       FARG_UART1_Write_data_+0 
	CALL        _UART1_Write+0, 0
;MIDImon.c,217 :: 		}
L_end_PrintHex:
	RETURN      0
; end of _PrintHex

_PrintHexSp:

;MIDImon.c,220 :: 		void PrintHexSp(unsigned char i) {
;MIDImon.c,223 :: 		hi = i & 0xF0;                                                              // high nibble
	MOVLW       240
	ANDWF       FARG_PrintHexSp_i+0, 0 
	MOVWF       R2 
	MOVF        R2, 0 
	MOVWF       PrintHexSp_hi_L0+0 
;MIDImon.c,224 :: 		hi = hi >> 4;
	MOVF        R2, 0 
	MOVWF       R0 
	RRCF        R0, 1 
	BCF         R0, 7 
	RRCF        R0, 1 
	BCF         R0, 7 
	RRCF        R0, 1 
	BCF         R0, 7 
	RRCF        R0, 1 
	BCF         R0, 7 
	MOVF        R0, 0 
	MOVWF       PrintHexSp_hi_L0+0 
;MIDImon.c,225 :: 		hi = hi + '0';
	MOVLW       48
	ADDWF       R0, 0 
	MOVWF       R1 
	MOVF        R1, 0 
	MOVWF       PrintHexSp_hi_L0+0 
;MIDImon.c,226 :: 		if (hi > '9') hi = hi + 7;
	MOVF        R1, 0 
	SUBLW       57
	BTFSC       STATUS+0, 0 
	GOTO        L_PrintHexSp25
	MOVLW       7
	ADDWF       PrintHexSp_hi_L0+0, 1 
L_PrintHexSp25:
;MIDImon.c,227 :: 		lo = (i & 0x0F) + '0';                                                      // low nibble
	MOVLW       15
	ANDWF       FARG_PrintHexSp_i+0, 0 
	MOVWF       R0 
	MOVLW       48
	ADDWF       R0, 0 
	MOVWF       R1 
	MOVF        R1, 0 
	MOVWF       PrintHexSp_lo_L0+0 
;MIDImon.c,228 :: 		if (lo>'9') lo=lo+7;
	MOVF        R1, 0 
	SUBLW       57
	BTFSC       STATUS+0, 0 
	GOTO        L_PrintHexSp26
	MOVLW       7
	ADDWF       PrintHexSp_lo_L0+0, 1 
L_PrintHexSp26:
;MIDImon.c,230 :: 		UART1_Write(hi);
	MOVF        PrintHexSp_hi_L0+0, 0 
	MOVWF       FARG_UART1_Write_data_+0 
	CALL        _UART1_Write+0, 0
;MIDImon.c,231 :: 		UART1_Write(lo);
	MOVF        PrintHexSp_lo_L0+0, 0 
	MOVWF       FARG_UART1_Write_data_+0 
	CALL        _UART1_Write+0, 0
;MIDImon.c,232 :: 		UART1_Write(' ');
	MOVLW       32
	MOVWF       FARG_UART1_Write_data_+0 
	CALL        _UART1_Write+0, 0
;MIDImon.c,233 :: 		}
L_end_PrintHexSp:
	RETURN      0
; end of _PrintHexSp

_getparams:

;MIDImon.c,236 :: 		char getparams(char* tempstring){
;MIDImon.c,241 :: 		unsigned int         pointer1=0;                                                // pointer within string
	CLRF        getparams_pointer1_L0+0 
	CLRF        getparams_pointer1_L0+1 
	CLRF        getparams_pointer2_L0+0 
	CLRF        getparams_pointer2_L0+1 
;MIDImon.c,244 :: 		oldcmd=cmd;                                                                 // remember old value
	MOVF        _cmd+0, 0 
	MOVWF       getparams_oldcmd_L0+0 
;MIDImon.c,245 :: 		nparams = 0;                                                                // initialise
	CLRF        _nparams+0 
;MIDImon.c,246 :: 		pointer1 = 0;                                                               // initialise
	CLRF        getparams_pointer1_L0+0 
	CLRF        getparams_pointer1_L0+1 
;MIDImon.c,248 :: 		for ( n = 0 ; n < 8 ; n++){                                                 // count 0 to 7
	CLRF        getparams_n_L0+0 
	CLRF        getparams_n_L0+1 
L_getparams27:
	MOVLW       128
	XORWF       getparams_n_L0+1, 0 
	MOVWF       R0 
	MOVLW       128
	SUBWF       R0, 0 
	BTFSS       STATUS+0, 2 
	GOTO        L__getparams104
	MOVLW       8
	SUBWF       getparams_n_L0+0, 0 
L__getparams104:
	BTFSC       STATUS+0, 0 
	GOTO        L_getparams28
;MIDImon.c,250 :: 		tempchar=1;                                                             // init
	MOVLW       1
	MOVWF       getparams_tempchar_L0+0 
;MIDImon.c,251 :: 		do {
L_getparams30:
;MIDImon.c,252 :: 		tempchar = tempstring[pointer1++];
	MOVF        getparams_pointer1_L0+0, 0 
	ADDWF       FARG_getparams_tempstring+0, 0 
	MOVWF       FSR0L+0 
	MOVF        getparams_pointer1_L0+1, 0 
	ADDWFC      FARG_getparams_tempstring+1, 0 
	MOVWF       FSR0L+1 
	MOVF        POSTINC0+0, 0 
	MOVWF       R1 
	MOVF        R1, 0 
	MOVWF       getparams_tempchar_L0+0 
	INFSNZ      getparams_pointer1_L0+0, 1 
	INCF        getparams_pointer1_L0+1, 1 
;MIDImon.c,253 :: 		} while (tempchar == 0x20);
	MOVF        R1, 0 
	XORLW       32
	BTFSC       STATUS+0, 2 
	GOTO        L_getparams30
;MIDImon.c,254 :: 		pointer1--;                                                             // leave pointer after param
	MOVLW       1
	SUBWF       getparams_pointer1_L0+0, 1 
	MOVLW       0
	SUBWFB      getparams_pointer1_L0+1, 1 
;MIDImon.c,257 :: 		if ((tempchar != 0) && (nparams < 8)){
	MOVF        getparams_tempchar_L0+0, 0 
	XORLW       0
	BTFSC       STATUS+0, 2 
	GOTO        L_getparams35
	MOVLW       8
	SUBWF       _nparams+0, 0 
	BTFSC       STATUS+0, 0 
	GOTO        L_getparams35
L__getparams93:
;MIDImon.c,258 :: 		nparams++;
	INCF        _nparams+0, 1 
;MIDImon.c,259 :: 		}
L_getparams35:
;MIDImon.c,261 :: 		if (n == 0){                                                            // only for param 0
	MOVLW       0
	XORWF       getparams_n_L0+1, 0 
	BTFSS       STATUS+0, 2 
	GOTO        L__getparams105
	MOVLW       0
	XORWF       getparams_n_L0+0, 0 
L__getparams105:
	BTFSS       STATUS+0, 2 
	GOTO        L_getparams36
;MIDImon.c,262 :: 		tempchar=tempstring[pointer1];                                      // get only first letter
	MOVF        getparams_pointer1_L0+0, 0 
	ADDWF       FARG_getparams_tempstring+0, 0 
	MOVWF       FSR0L+0 
	MOVF        getparams_pointer1_L0+1, 0 
	ADDWFC      FARG_getparams_tempstring+1, 0 
	MOVWF       FSR0L+1 
	MOVF        POSTINC0+0, 0 
	MOVWF       R1 
	MOVF        R1, 0 
	MOVWF       getparams_tempchar_L0+0 
;MIDImon.c,263 :: 		if ((tempchar > 0x60) && (tempchar < 0x7b)) {
	MOVF        R1, 0 
	SUBLW       96
	BTFSC       STATUS+0, 0 
	GOTO        L_getparams39
	MOVLW       123
	SUBWF       getparams_tempchar_L0+0, 0 
	BTFSC       STATUS+0, 0 
	GOTO        L_getparams39
L__getparams92:
;MIDImon.c,264 :: 		tempchar -= 0x20;                                               // to upper case
	MOVLW       32
	SUBWF       getparams_tempchar_L0+0, 1 
;MIDImon.c,265 :: 		}
L_getparams39:
;MIDImon.c,266 :: 		cmd=tempchar;
	MOVF        getparams_tempchar_L0+0, 0 
	MOVWF       _cmd+0 
;MIDImon.c,267 :: 		}
L_getparams36:
;MIDImon.c,269 :: 		tempchar=1;                                                             // initialise
	MOVLW       1
	MOVWF       getparams_tempchar_L0+0 
;MIDImon.c,270 :: 		if (nparams != 0){                                                      // only for non-blank line
	MOVF        _nparams+0, 0 
	XORLW       0
	BTFSC       STATUS+0, 2 
	GOTO        L_getparams40
;MIDImon.c,272 :: 		pointer2=0;                                                         // initialise
	CLRF        getparams_pointer2_L0+0 
	CLRF        getparams_pointer2_L0+1 
;MIDImon.c,273 :: 		do {
L_getparams41:
;MIDImon.c,274 :: 		tempchar = tempstring[pointer1++];                              // get char
	MOVF        getparams_pointer1_L0+0, 0 
	ADDWF       FARG_getparams_tempstring+0, 0 
	MOVWF       FSR0L+0 
	MOVF        getparams_pointer1_L0+1, 0 
	ADDWFC      FARG_getparams_tempstring+1, 0 
	MOVWF       FSR0L+1 
	MOVF        POSTINC0+0, 0 
	MOVWF       R1 
	MOVF        R1, 0 
	MOVWF       getparams_tempchar_L0+0 
	INFSNZ      getparams_pointer1_L0+0, 1 
	INCF        getparams_pointer1_L0+1, 1 
;MIDImon.c,275 :: 		if ((tempchar > 0x60) && (tempchar < 0x7b)) {
	MOVF        R1, 0 
	SUBLW       96
	BTFSC       STATUS+0, 0 
	GOTO        L_getparams46
	MOVLW       123
	SUBWF       getparams_tempchar_L0+0, 0 
	BTFSC       STATUS+0, 0 
	GOTO        L_getparams46
L__getparams91:
;MIDImon.c,276 :: 		tempchar -= 0x20;                                           // to upper case
	MOVLW       32
	SUBWF       getparams_tempchar_L0+0, 1 
;MIDImon.c,277 :: 		}
L_getparams46:
;MIDImon.c,278 :: 		param[n][pointer2++] = tempchar;                                // and store it
	MOVLW       20
	MOVWF       R0 
	MOVLW       0
	MOVWF       R1 
	MOVF        getparams_n_L0+0, 0 
	MOVWF       R4 
	MOVF        getparams_n_L0+1, 0 
	MOVWF       R5 
	CALL        _Mul_16X16_U+0, 0
	MOVLW       _param+0
	ADDWF       R0, 1 
	MOVLW       hi_addr(_param+0)
	ADDWFC      R1, 1 
	MOVF        getparams_pointer2_L0+0, 0 
	ADDWF       R0, 0 
	MOVWF       FSR1L+0 
	MOVF        getparams_pointer2_L0+1, 0 
	ADDWFC      R1, 0 
	MOVWF       FSR1L+1 
	MOVF        getparams_tempchar_L0+0, 0 
	MOVWF       POSTINC1+0 
	INFSNZ      getparams_pointer2_L0+0, 1 
	INCF        getparams_pointer2_L0+1, 1 
;MIDImon.c,279 :: 		} while ((tempchar > 0x20) && (tempchar < 0x7f) && (pointer2 < 20)); // text
	MOVF        getparams_tempchar_L0+0, 0 
	SUBLW       32
	BTFSC       STATUS+0, 0 
	GOTO        L__getparams90
	MOVLW       127
	SUBWF       getparams_tempchar_L0+0, 0 
	BTFSC       STATUS+0, 0 
	GOTO        L__getparams90
	MOVLW       0
	SUBWF       getparams_pointer2_L0+1, 0 
	BTFSS       STATUS+0, 2 
	GOTO        L__getparams106
	MOVLW       20
	SUBWF       getparams_pointer2_L0+0, 0 
L__getparams106:
	BTFSC       STATUS+0, 0 
	GOTO        L__getparams90
	GOTO        L_getparams41
L__getparams90:
;MIDImon.c,280 :: 		param[n][pointer2-1]=0;                                             // zero terminate param string
	MOVLW       20
	MOVWF       R0 
	MOVLW       0
	MOVWF       R1 
	MOVF        getparams_n_L0+0, 0 
	MOVWF       R4 
	MOVF        getparams_n_L0+1, 0 
	MOVWF       R5 
	CALL        _Mul_16X16_U+0, 0
	MOVLW       _param+0
	ADDWF       R0, 0 
	MOVWF       R2 
	MOVLW       hi_addr(_param+0)
	ADDWFC      R1, 0 
	MOVWF       R3 
	MOVLW       1
	SUBWF       getparams_pointer2_L0+0, 0 
	MOVWF       R0 
	MOVLW       0
	SUBWFB      getparams_pointer2_L0+1, 0 
	MOVWF       R1 
	MOVF        R0, 0 
	ADDWF       R2, 0 
	MOVWF       FSR1L+0 
	MOVF        R1, 0 
	ADDWFC      R3, 0 
	MOVWF       FSR1L+1 
	CLRF        POSTINC1+0 
;MIDImon.c,281 :: 		if((tempchar == 0)||(n == 9)){                                      // no more params if end of line
	MOVF        getparams_tempchar_L0+0, 0 
	XORLW       0
	BTFSC       STATUS+0, 2 
	GOTO        L__getparams89
	MOVLW       0
	XORWF       getparams_n_L0+1, 0 
	BTFSS       STATUS+0, 2 
	GOTO        L__getparams107
	MOVLW       9
	XORWF       getparams_n_L0+0, 0 
L__getparams107:
	BTFSC       STATUS+0, 2 
	GOTO        L__getparams89
	GOTO        L_getparams51
L__getparams89:
;MIDImon.c,282 :: 		break;
	GOTO        L_getparams28
;MIDImon.c,283 :: 		}
L_getparams51:
;MIDImon.c,284 :: 		}
L_getparams40:
;MIDImon.c,248 :: 		for ( n = 0 ; n < 8 ; n++){                                                 // count 0 to 7
	INFSNZ      getparams_n_L0+0, 1 
	INCF        getparams_n_L0+1, 1 
;MIDImon.c,285 :: 		}
	GOTO        L_getparams27
L_getparams28:
;MIDImon.c,288 :: 		for (n = 0; n < nparams ; n++){                                             // parms are 0 to 7
	CLRF        getparams_n_L0+0 
	CLRF        getparams_n_L0+1 
L_getparams52:
	MOVLW       128
	XORWF       getparams_n_L0+1, 0 
	MOVWF       R0 
	MOVLW       128
	SUBWF       R0, 0 
	BTFSS       STATUS+0, 2 
	GOTO        L__getparams108
	MOVF        _nparams+0, 0 
	SUBWF       getparams_n_L0+0, 0 
L__getparams108:
	BTFSC       STATUS+0, 0 
	GOTO        L_getparams53
;MIDImon.c,289 :: 		tempchar2=1;                                                            // initialise
	MOVLW       1
	MOVWF       getparams_tempchar2_L0+0 
;MIDImon.c,290 :: 		pointer1=0;                                                             // initialise
	CLRF        getparams_pointer1_L0+0 
	CLRF        getparams_pointer1_L0+1 
;MIDImon.c,291 :: 		upar[n]=0;                                                              // initialise
	MOVF        getparams_n_L0+0, 0 
	MOVWF       R0 
	MOVF        getparams_n_L0+1, 0 
	MOVWF       R1 
	RLCF        R0, 1 
	BCF         R0, 0 
	RLCF        R1, 1 
	MOVLW       _upar+0
	ADDWF       R0, 0 
	MOVWF       FSR1L+0 
	MOVLW       hi_addr(_upar+0)
	ADDWFC      R1, 0 
	MOVWF       FSR1L+1 
	CLRF        POSTINC1+0 
	CLRF        POSTINC1+0 
;MIDImon.c,292 :: 		do {
L_getparams55:
;MIDImon.c,293 :: 		tempchar = param[n][pointer1++];
	MOVLW       20
	MOVWF       R0 
	MOVLW       0
	MOVWF       R1 
	MOVF        getparams_n_L0+0, 0 
	MOVWF       R4 
	MOVF        getparams_n_L0+1, 0 
	MOVWF       R5 
	CALL        _Mul_16X16_U+0, 0
	MOVLW       _param+0
	ADDWF       R0, 1 
	MOVLW       hi_addr(_param+0)
	ADDWFC      R1, 1 
	MOVF        getparams_pointer1_L0+0, 0 
	ADDWF       R0, 0 
	MOVWF       FSR0L+0 
	MOVF        getparams_pointer1_L0+1, 0 
	ADDWFC      R1, 0 
	MOVWF       FSR0L+1 
	MOVF        POSTINC0+0, 0 
	MOVWF       R1 
	MOVF        R1, 0 
	MOVWF       getparams_tempchar_L0+0 
	INFSNZ      getparams_pointer1_L0+0, 1 
	INCF        getparams_pointer1_L0+1, 1 
;MIDImon.c,295 :: 		if ( tempchar != 0 ){
	MOVF        R1, 0 
	XORLW       0
	BTFSC       STATUS+0, 2 
	GOTO        L_getparams58
;MIDImon.c,296 :: 		upar[n] = upar[n] * 0x10;                                       // next most signicant hex digit
	MOVF        getparams_n_L0+0, 0 
	MOVWF       R0 
	MOVF        getparams_n_L0+1, 0 
	MOVWF       R1 
	RLCF        R0, 1 
	BCF         R0, 0 
	RLCF        R1, 1 
	MOVLW       _upar+0
	ADDWF       R0, 0 
	MOVWF       R5 
	MOVLW       hi_addr(_upar+0)
	ADDWFC      R1, 0 
	MOVWF       R6 
	MOVFF       R5, FSR0L+0
	MOVFF       R6, FSR0H+0
	MOVF        POSTINC0+0, 0 
	MOVWF       R3 
	MOVF        POSTINC0+0, 0 
	MOVWF       R4 
	MOVF        R3, 0 
	MOVWF       R0 
	MOVF        R4, 0 
	MOVWF       R1 
	RLCF        R0, 1 
	BCF         R0, 0 
	RLCF        R1, 1 
	RLCF        R0, 1 
	BCF         R0, 0 
	RLCF        R1, 1 
	RLCF        R0, 1 
	BCF         R0, 0 
	RLCF        R1, 1 
	RLCF        R0, 1 
	BCF         R0, 0 
	RLCF        R1, 1 
	MOVFF       R5, FSR1L+0
	MOVFF       R6, FSR1H+0
	MOVF        R0, 0 
	MOVWF       POSTINC1+0 
	MOVF        R1, 0 
	MOVWF       POSTINC1+0 
;MIDImon.c,297 :: 		}            tempchar2=tempchar;
L_getparams58:
	MOVF        getparams_tempchar_L0+0, 0 
	MOVWF       getparams_tempchar2_L0+0 
;MIDImon.c,299 :: 		if ((tempchar < 0x30) || (tempchar > 0x46)) {
	MOVLW       48
	SUBWF       getparams_tempchar_L0+0, 0 
	BTFSS       STATUS+0, 0 
	GOTO        L__getparams88
	MOVF        getparams_tempchar_L0+0, 0 
	SUBLW       70
	BTFSS       STATUS+0, 0 
	GOTO        L__getparams88
	GOTO        L_getparams61
L__getparams88:
;MIDImon.c,300 :: 		tempchar = 0x00;                                                // non-hex to zero
	CLRF        getparams_tempchar_L0+0 
;MIDImon.c,301 :: 		}
L_getparams61:
;MIDImon.c,302 :: 		if ((tempchar > 0x39) && (tempchar < 0x41)) {
	MOVF        getparams_tempchar_L0+0, 0 
	SUBLW       57
	BTFSC       STATUS+0, 0 
	GOTO        L_getparams64
	MOVLW       65
	SUBWF       getparams_tempchar_L0+0, 0 
	BTFSC       STATUS+0, 0 
	GOTO        L_getparams64
L__getparams87:
;MIDImon.c,303 :: 		tempchar = 0x00;                                                // non-hex to zero
	CLRF        getparams_tempchar_L0+0 
;MIDImon.c,304 :: 		}
L_getparams64:
;MIDImon.c,305 :: 		if ((tempchar > 0x40) && (tempchar < 0x47)) {
	MOVF        getparams_tempchar_L0+0, 0 
	SUBLW       64
	BTFSC       STATUS+0, 0 
	GOTO        L_getparams67
	MOVLW       71
	SUBWF       getparams_tempchar_L0+0, 0 
	BTFSC       STATUS+0, 0 
	GOTO        L_getparams67
L__getparams86:
;MIDImon.c,306 :: 		tempchar -= 0x37;                                               // to bin
	MOVLW       55
	SUBWF       getparams_tempchar_L0+0, 1 
;MIDImon.c,307 :: 		}
L_getparams67:
;MIDImon.c,308 :: 		if ((tempchar > 0x2f) && (tempchar < 0x3a)) {
	MOVF        getparams_tempchar_L0+0, 0 
	SUBLW       47
	BTFSC       STATUS+0, 0 
	GOTO        L_getparams70
	MOVLW       58
	SUBWF       getparams_tempchar_L0+0, 0 
	BTFSC       STATUS+0, 0 
	GOTO        L_getparams70
L__getparams85:
;MIDImon.c,309 :: 		tempchar -= 0x30;                                               // to bin
	MOVLW       48
	SUBWF       getparams_tempchar_L0+0, 1 
;MIDImon.c,310 :: 		}
L_getparams70:
;MIDImon.c,311 :: 		upar[n] += tempchar;
	MOVF        getparams_n_L0+0, 0 
	MOVWF       R0 
	MOVF        getparams_n_L0+1, 0 
	MOVWF       R1 
	RLCF        R0, 1 
	BCF         R0, 0 
	RLCF        R1, 1 
	MOVLW       _upar+0
	ADDWF       R0, 0 
	MOVWF       R2 
	MOVLW       hi_addr(_upar+0)
	ADDWFC      R1, 0 
	MOVWF       R3 
	MOVFF       R2, FSR0L+0
	MOVFF       R3, FSR0H+0
	MOVF        getparams_tempchar_L0+0, 0 
	ADDWF       POSTINC0+0, 0 
	MOVWF       R0 
	MOVLW       0
	ADDWFC      POSTINC0+0, 0 
	MOVWF       R1 
	MOVFF       R2, FSR1L+0
	MOVFF       R3, FSR1H+0
	MOVF        R0, 0 
	MOVWF       POSTINC1+0 
	MOVF        R1, 0 
	MOVWF       POSTINC1+0 
;MIDImon.c,312 :: 		} while (tempchar2 != 0);
	MOVF        getparams_tempchar2_L0+0, 0 
	XORLW       0
	BTFSS       STATUS+0, 2 
	GOTO        L_getparams55
;MIDImon.c,288 :: 		for (n = 0; n < nparams ; n++){                                             // parms are 0 to 7
	INFSNZ      getparams_n_L0+0, 1 
	INCF        getparams_n_L0+1, 1 
;MIDImon.c,313 :: 		}
	GOTO        L_getparams52
L_getparams53:
;MIDImon.c,315 :: 		if (nparams == 0) {
	MOVF        _nparams+0, 0 
	XORLW       0
	BTFSS       STATUS+0, 2 
	GOTO        L_getparams71
;MIDImon.c,316 :: 		cmd = oldcmd;
	MOVF        getparams_oldcmd_L0+0, 0 
	MOVWF       _cmd+0 
;MIDImon.c,317 :: 		}
L_getparams71:
;MIDImon.c,318 :: 		return cmd;
	MOVF        _cmd+0, 0 
	MOVWF       R0 
;MIDImon.c,319 :: 		}
L_end_getparams:
	RETURN      0
; end of _getparams

_linein:

;MIDImon.c,325 :: 		void linein(char* pstring){
;MIDImon.c,326 :: 		char inChar = 0;
	CLRF        linein_inChar_L0+0 
;MIDImon.c,328 :: 		while(inChar != '\r'){
L_linein72:
	MOVF        linein_inChar_L0+0, 0 
	XORLW       13
	BTFSC       STATUS+0, 2 
	GOTO        L_linein73
;MIDImon.c,331 :: 		if (UART1_Data_Ready()){
	CALL        _UART1_Data_Ready+0, 0
	MOVF        R0, 1 
	BTFSC       STATUS+0, 2 
	GOTO        L_linein74
;MIDImon.c,332 :: 		inChar = UART1_Read();
	CALL        _UART1_Read+0, 0
	MOVF        R0, 0 
	MOVWF       linein_inChar_L0+0 
;MIDImon.c,333 :: 		UART1_Write(inChar);
	MOVF        R0, 0 
	MOVWF       FARG_UART1_Write_data_+0 
	CALL        _UART1_Write+0, 0
;MIDImon.c,334 :: 		if(inChar == '\r'){
	MOVF        linein_inChar_L0+0, 0 
	XORLW       13
	BTFSS       STATUS+0, 2 
	GOTO        L_linein75
;MIDImon.c,335 :: 		UART1_Write('\n');
	MOVLW       10
	MOVWF       FARG_UART1_Write_data_+0 
	CALL        _UART1_Write+0, 0
;MIDImon.c,336 :: 		*pstring ++= '\0';
	MOVFF       FARG_linein_pstring+0, FSR1L+0
	MOVFF       FARG_linein_pstring+1, FSR1H+0
	CLRF        POSTINC1+0 
	INFSNZ      FARG_linein_pstring+0, 1 
	INCF        FARG_linein_pstring+1, 1 
;MIDImon.c,337 :: 		}
	GOTO        L_linein76
L_linein75:
;MIDImon.c,339 :: 		if (inChar != 0x7f ){                                           // if not backspace
	MOVF        linein_inChar_L0+0, 0 
	XORLW       127
	BTFSC       STATUS+0, 2 
	GOTO        L_linein77
;MIDImon.c,340 :: 		*pstring++ = inChar;
	MOVFF       FARG_linein_pstring+0, FSR1L+0
	MOVFF       FARG_linein_pstring+1, FSR1H+0
	MOVF        linein_inChar_L0+0, 0 
	MOVWF       POSTINC1+0 
	INFSNZ      FARG_linein_pstring+0, 1 
	INCF        FARG_linein_pstring+1, 1 
;MIDImon.c,341 :: 		}
L_linein77:
;MIDImon.c,342 :: 		if (inChar == 0x7f ){                                           // handle backspace
	MOVF        linein_inChar_L0+0, 0 
	XORLW       127
	BTFSS       STATUS+0, 2 
	GOTO        L_linein78
;MIDImon.c,343 :: 		*--pstring = 0x00;
	MOVLW       1
	SUBWF       FARG_linein_pstring+0, 1 
	MOVLW       0
	SUBWFB      FARG_linein_pstring+1, 1 
	MOVFF       FARG_linein_pstring+0, FSR1L+0
	MOVFF       FARG_linein_pstring+1, FSR1H+0
	CLRF        POSTINC1+0 
;MIDImon.c,344 :: 		}
L_linein78:
;MIDImon.c,345 :: 		}
L_linein76:
;MIDImon.c,346 :: 		}
L_linein74:
;MIDImon.c,347 :: 		if(u2_rx_flag){
	MOVF        _u2_rx_flag+0, 1 
	BTFSC       STATUS+0, 2 
	GOTO        L_linein79
;MIDImon.c,348 :: 		u2_rx_flag = 0;
	CLRF        _u2_rx_flag+0 
;MIDImon.c,349 :: 		if(u2_rx_data > 127){
	MOVF        _u2_rx_data+0, 0 
	SUBLW       127
	BTFSC       STATUS+0, 0 
	GOTO        L_linein80
;MIDImon.c,350 :: 		UART1_Write_Text("\r\n");
	MOVLW       ?lstr19_MIDImon+0
	MOVWF       FARG_UART1_Write_Text_uart_text+0 
	MOVLW       hi_addr(?lstr19_MIDImon+0)
	MOVWF       FARG_UART1_Write_Text_uart_text+1 
	CALL        _UART1_Write_Text+0, 0
;MIDImon.c,351 :: 		UART1_Write_Text(int_rx_buf);                                       //
	MOVLW       _int_rx_buf+0
	MOVWF       FARG_UART1_Write_Text_uart_text+0 
	MOVLW       hi_addr(_int_rx_buf+0)
	MOVWF       FARG_UART1_Write_Text_uart_text+1 
	CALL        _UART1_Write_Text+0, 0
;MIDImon.c,352 :: 		}
	GOTO        L_linein81
L_linein80:
;MIDImon.c,354 :: 		UART1_Write_Text("-");
	MOVLW       ?lstr20_MIDImon+0
	MOVWF       FARG_UART1_Write_Text_uart_text+0 
	MOVLW       hi_addr(?lstr20_MIDImon+0)
	MOVWF       FARG_UART1_Write_Text_uart_text+1 
	CALL        _UART1_Write_Text+0, 0
;MIDImon.c,355 :: 		UART1_Write_Text(int_rx_buf);                                       //
	MOVLW       _int_rx_buf+0
	MOVWF       FARG_UART1_Write_Text_uart_text+0 
	MOVLW       hi_addr(_int_rx_buf+0)
	MOVWF       FARG_UART1_Write_Text_uart_text+1 
	CALL        _UART1_Write_Text+0, 0
;MIDImon.c,356 :: 		}
L_linein81:
;MIDImon.c,357 :: 		}
L_linein79:
;MIDImon.c,358 :: 		}
	GOTO        L_linein72
L_linein73:
;MIDImon.c,359 :: 		}
L_end_linein:
	RETURN      0
; end of _linein

_chin:

;MIDImon.c,362 :: 		char chin(void){
;MIDImon.c,365 :: 		while(!UART1_Data_Ready());
L_chin82:
	CALL        _UART1_Data_Ready+0, 0
	MOVF        R0, 1 
	BTFSS       STATUS+0, 2 
	GOTO        L_chin83
	GOTO        L_chin82
L_chin83:
;MIDImon.c,366 :: 		temp = UART1_Read();
	CALL        _UART1_Read+0, 0
;MIDImon.c,367 :: 		return temp;
;MIDImon.c,368 :: 		}
L_end_chin:
	RETURN      0
; end of _chin

_chout:

;MIDImon.c,371 :: 		void chout(char outchar){
;MIDImon.c,373 :: 		UART1_Write(outchar);
	MOVF        FARG_chout_outchar+0, 0 
	MOVWF       FARG_UART1_Write_data_+0 
	CALL        _UART1_Write+0, 0
;MIDImon.c,374 :: 		if(outchar == 0x0d){
	MOVF        FARG_chout_outchar+0, 0 
	XORLW       13
	BTFSS       STATUS+0, 2 
	GOTO        L_chout84
;MIDImon.c,375 :: 		UART1_Write(0x0a);
	MOVLW       10
	MOVWF       FARG_UART1_Write_data_+0 
	CALL        _UART1_Write+0, 0
;MIDImon.c,376 :: 		}
L_chout84:
;MIDImon.c,377 :: 		}
L_end_chout:
	RETURN      0
; end of _chout
