#line 1 "C:/PIC/MikroC/PIC18/PIC18F47K42/MIDI/MIDImon/MIDImon.c"
#line 27 "C:/PIC/MikroC/PIC18/PIC18F47K42/MIDI/MIDImon/MIDImon.c"
void linein(char* pstring);
char getparams(char* tempstring);
void PrintHex(unsigned char i);
void PrintHexSp(unsigned char i);
void midi_off(void);


void cmdo(void);
void cmdp(void);
void cmdz(void);


char rxbuff[20];
char rxidx;
unsigned char newcmd;
unsigned char cmd;
unsigned char u1_rx_data;
unsigned char u1_rx_flag = 0;
unsigned char u2_rx_data;
unsigned char u2_rx_flag = 0;
unsigned char linebuff[120];
unsigned char param[8][20];
unsigned int upar[8];
unsigned char nparams;
unsigned char int_rx_buf[4];



unsigned char midi_a[] = {0xb0, 0x3a, 0x7f
 , 0xb0, 0x35, 0x7f , 0xb0, 0x36, 0x3f
 , 0x90, 0x30, 0x7f , 0x90, 0x35, 0x7f
 , 0x90, 0x20, 0x7f , 0x90, 0x25, 0x7f
 };

void interrupt() {
 if(U2RXIF_bit) {
 u2_rx_data = UART2_Read();
 ByteToHex(u2_rx_data, int_rx_buf);
 u2_rx_flag = 1;
 }
}

void main() {
 rxidx = 0;
 ANSELA = 0;
 ANSELB = 0;
 ANSELC = 0;
 ANSELD = 0;
 TRISA = 0;
 TRISB = 0;
 TRISC = 0;
 TRISD = 0;
 LATA = 0;
 LATB = 0x00;
 LATC = 0x00;
 LATD = 0x00;


 UART2_Init(31250);
 UART1_Init(115200);
 Delay_ms(100);
 newcmd = '?';
 cmd = newcmd;

 UART1_Write_Text("\r\n\nMIDI Monitor 30 Aug 2019\r\n");
 UART1_Write_Text("MIDI Out RB5, MIDI In RB2 (via interface hardware)\r\n");
 UART1_Write_Text("? for help\r\n");

 U2RXIE_bit = 1;
 U2RXIF_bit = 0;

 GIE_bit = 1;

 while(1){
 linein(linebuff);
 newcmd = getparams(linebuff);
 switch(newcmd){
 case 'O':
 cmdo();
 break;

 case 'P':
 cmdp();
 break;

 case 'Z':
 cmdz();
 break;

 case '?':
 UART1_Write_Text("\r\n?        List Commands");
 UART1_Write_Text("\r\no cc ..  Output hex to MIDI");
 UART1_Write_Text("\r\np        Parameter test");
 UART1_Write_Text("\r\nz        Bassboy send test\r\n");
 break;

 default:{
 UART1_Write_Text("\r\ncommand not recognised\r\n");
 break;
 }
 }
 }
}




void cmdo(){
unsigned char pc;

 UART1_Write_Text("MIDI out ");
 for(pc = 1; pc < nparams; pc++){
 UART2_Write(upar[pc]);
 PrintHexSp(upar[pc]);
 }
 UART1_Write_Text("\r\n");
}

void cmdp(){
 unsigned char paramcount;
 PrintHex(nparams);
 UART1_Write_Text(" parameters\r\n");
 for( paramcount = 0 ; paramcount < 8 ; paramcount++ ){
 UART1_Write_Text("parameter ");
 PrintHexSp(paramcount);
 PrintHex((upar[paramcount] >> 8) & 0xff);
 PrintHex((upar[paramcount]) & 0xff);
 UART1_Write_Text("\r\n");
 }
}
#line 177 "C:/PIC/MikroC/PIC18/PIC18F47K42/MIDI/MIDImon/MIDImon.c"
void cmdz(){
unsigned char pc;

 UART1_Write_Text("\r\nBassBoy MIDI out on RB5\r\n");
 for(pc = 0; pc < sizeof(midi_a); pc++){
 UART2_Write(midi_a[pc]);
 if(midi_a[pc] > 127){
 Delay_ms(1000);
 UART1_Write_Text("\r\n");
 }
 PrintHexSp(midi_a[pc]);

 }
 midi_off();
 UART1_Write_Text("\r\n");
}


void midi_off(){
 Delay_ms(2000);
 UART1_Write_Text("\r\nB0 7B 00 (all notes off)\r\n");
 UART2_Write(0xb0);
 UART2_Write(0x7b);
 UART2_Write(0x00);
 UART1_Write_Text("\r\ndone...\r\n");
}


void PrintHex(unsigned char i) {
unsigned char hi,lo;

 hi = i & 0xF0;
 hi = hi >> 4;
 hi = hi + '0';
 if (hi > '9') hi = hi + 7;
 lo = (i & 0x0F) + '0';
 if (lo>'9') lo=lo+7;

 UART1_Write(hi);
 UART1_Write(lo);
}


void PrintHexSp(unsigned char i) {
unsigned char hi,lo;

 hi = i & 0xF0;
 hi = hi >> 4;
 hi = hi + '0';
 if (hi > '9') hi = hi + 7;
 lo = (i & 0x0F) + '0';
 if (lo>'9') lo=lo+7;

 UART1_Write(hi);
 UART1_Write(lo);
 UART1_Write(' ');
}


char getparams(char* tempstring){
char oldcmd;
int n;
char tempchar;
char tempchar2;
unsigned int pointer1=0;
unsigned int pointer2=0;

 oldcmd=cmd;
 nparams = 0;
 pointer1 = 0;

 for ( n = 0 ; n < 8 ; n++){

 tempchar=1;
 do {
 tempchar = tempstring[pointer1++];
 } while (tempchar == 0x20);
 pointer1--;


 if ((tempchar != 0) && (nparams < 8)){
 nparams++;
 }

 if (n == 0){
 tempchar=tempstring[pointer1];
 if ((tempchar > 0x60) && (tempchar < 0x7b)) {
 tempchar -= 0x20;
 }
 cmd=tempchar;
 }

 tempchar=1;
 if (nparams != 0){

 pointer2=0;
 do {
 tempchar = tempstring[pointer1++];
 if ((tempchar > 0x60) && (tempchar < 0x7b)) {
 tempchar -= 0x20;
 }
 param[n][pointer2++] = tempchar;
 } while ((tempchar > 0x20) && (tempchar < 0x7f) && (pointer2 < 20));
 param[n][pointer2-1]=0;
 if((tempchar == 0)||(n == 9)){
 break;
 }
 }
 }


 for (n = 0; n < nparams ; n++){
 tempchar2=1;
 pointer1=0;
 upar[n]=0;
 do {
 tempchar = param[n][pointer1++];

 if ( tempchar != 0 ){
 upar[n] = upar[n] * 0x10;
 } tempchar2=tempchar;

 if ((tempchar < 0x30) || (tempchar > 0x46)) {
 tempchar = 0x00;
 }
 if ((tempchar > 0x39) && (tempchar < 0x41)) {
 tempchar = 0x00;
 }
 if ((tempchar > 0x40) && (tempchar < 0x47)) {
 tempchar -= 0x37;
 }
 if ((tempchar > 0x2f) && (tempchar < 0x3a)) {
 tempchar -= 0x30;
 }
 upar[n] += tempchar;
 } while (tempchar2 != 0);
 }

 if (nparams == 0) {
 cmd = oldcmd;
 }
 return cmd;
}





void linein(char* pstring){
char inChar = 0;

 while(inChar != '\r'){


 if (UART1_Data_Ready()){
 inChar = UART1_Read();
 UART1_Write(inChar);
 if(inChar == '\r'){
 UART1_Write('\n');
 *pstring ++= '\0';
 }
 else {
 if (inChar != 0x7f ){
 *pstring++ = inChar;
 }
 if (inChar == 0x7f ){
 *--pstring = 0x00;
 }
 }
 }
 if(u2_rx_flag){
 u2_rx_flag = 0;
 if(u2_rx_data > 127){
 UART1_Write_Text("\r\n");
 UART1_Write_Text(int_rx_buf);
 }
 else{
 UART1_Write_Text("-");
 UART1_Write_Text(int_rx_buf);
 }
 }
 }
}


char chin(void){
char temp;

 while(!UART1_Data_Ready());
 temp = UART1_Read();
 return temp;
}


void chout(char outchar){

 UART1_Write(outchar);
 if(outchar == 0x0d){
 UART1_Write(0x0a);
 }
}
