// Simple MIDI exercise - just for messing around
// UART2 tx on D6, rx on D7 - 31250 8,n,1

// pull-up on D7 helps clean up rx waveform


//    PIC18F45K22 on EasyPIC7, HS-PLL 32.0000 MHz, 8.0000 MHz Crystal
//    Sparkfun MIDI interface
//    mikroC PRO for PIC
//    - Turn on RX and TX UART switches (SW1.1 and SW2.1). (board specific)
//    - Put RX and TX UART jumpers (J3 and J4) in RS-232 or USB position,

unsigned char key = 0;                                       // keyboard key 0 to 7f
unsigned char velocity = 0;                                  // velocity 0 to 7f
unsigned char channel = 0;                                   // 0 to f for channel 1 to 16
unsigned char txt_conv[8];                                   // buffer for hex conversion
unsigned char midi_byte;                                     // store received byte

void main() {
    ANSELB = 0;                                              // Configure PORTB pins as digital
    ANSELC = 0;                                              // Configure PORTC pins as digital
    ANSELD = 0;                                              // Configure PORTD pins as digital else UART2 will not work
    TRISB = 0;
    
    UART1_Init(115200);                                      // Initialize UART1 for terminal display - at least 3x MIDI speed
    UART2_Init(31250);                                       // init UART2 for MIDI - 32us per bit
    Delay_ms(100);                                           // Wait for UART modules to stabilize

    UART1_Write_Text("\r\nMIDI receive\r\n");

    UART2_Write(0xc0 + channel);                             // program change
    //UART2_Write(40);                                         // trumpet
    UART2_Write(56);                                         // flute

    Delay_ms(100);                                           // Wait for MIDI device to stabilise

    while(1){
        if(UART2_Data_Ready()){                              // wait for MIDI byte
            midi_byte = UART2_Read();
            ByteToHex(midi_byte, txt_conv);
            if(midi_byte > 127){                             // status byte
                UART1_Write_Text("\r\n");
                UART1_Write_Text(txt_conv);
            }
            else{
                UART1_Write_Text(" ");
                UART1_Write_Text(txt_conv);
            }
        }
    }
}