// Simple MIDI exercise - just for messing around
// UART2 tx on D6, rx on D7 - 31250 8,n,1


//    MCU:             PIC18F45K22
//    Dev.Board:       EasyPIC7 - ac:UART
//    Oscillator:      HS-PLL 32.0000 MHz, 8.0000 MHz Crystal
//    Ext. Modules:    MIDI interface
//    SW:              mikroC PRO for PIC
//     - Turn on RX and TX UART switches (SW1.1 and SW2.1). (board specific)
//    - Put RX and TX UART jumpers (J3 and J4) in RS-232 or USB position,

unsigned char key = 0;                                       // keyboard key 0 to 7f
unsigned char velocity = 0;                                  // velocity 0 to 7f
unsigned char channel = 0;                                   // 0 to f for channel 1 to 16

void main() {
    ANSELB = 0;                     // Configure PORTC pins as digital
    TRISB = 0;
    
    UART1_Init(9600);               // Initialize UART module at 9600 bps
    UART2_Init(31250);
    Delay_ms(100);                  // Wait for UART module to stabilize

    UART1_Write_Text("\r\nStart\r\n");

    UART2_Write(0xc0 + channel);                    // program change
    //UART2_Write(40);                                // trumpet
    UART2_Write(56);                                // flute

    while(1){
        channel = 0;
        for(key = 36; key < 97; key++){
            UART2_Write(0x90 + channel);                    // note on
            UART2_Write(key);
            UART2_Write(0x0f);                              // piano volume
            Delay_ms(300);
            UART2_Write(0x80 + channel);                    // note off
            UART2_Write(key);
            UART2_Write(0x0f);
        }
        channel = 9;
        for(key = 36; key < 60; key++){
            UART2_Write(0x90 + channel);                    // note on
            UART2_Write(key);
            UART2_Write(0x2f);                              // drums volume
            Delay_ms(500);
            UART2_Write(0x80 + channel);                    // note off
            UART2_Write(key);
            UART2_Write(0x7f);
        }
    }
}