
_interrupt:

;PICmon8.c,73 :: 		void interrupt() {                                                              // Interrupt routine
;PICmon8.c,74 :: 		if(U2RXIF_bit) {                                                            // Checks for Receive Interrupt Flag bit
	BTFSS       U2RXIF_bit+0, BitPos(U2RXIF_bit+0) 
	GOTO        L_interrupt0
;PICmon8.c,75 :: 		u2_rx_data = UART2_Read();                                              // Storing read data
	CALL        _UART2_Read+0, 0
	MOVF        R0, 0 
	MOVWF       _u2_rx_data+0 
;PICmon8.c,76 :: 		ByteToHex(u2_rx_data, int_rx_buf);
	MOVF        R0, 0 
	MOVWF       FARG_ByteToHex_input+0 
	MOVLW       _int_rx_buf+0
	MOVWF       FARG_ByteToHex_output+0 
	MOVLW       hi_addr(_int_rx_buf+0)
	MOVWF       FARG_ByteToHex_output+1 
	CALL        _ByteToHex+0, 0
;PICmon8.c,77 :: 		u2_rx_flag = 1;
	MOVLW       1
	MOVWF       _u2_rx_flag+0 
;PICmon8.c,78 :: 		}
L_interrupt0:
;PICmon8.c,79 :: 		}
L_end_interrupt:
L__interrupt111:
	RETFIE      1
; end of _interrupt

_main:

;PICmon8.c,81 :: 		void main() {
;PICmon8.c,82 :: 		rxidx  = 0;                                                                 // Initialisation of variable
	CLRF        _rxidx+0 
;PICmon8.c,83 :: 		ANSELA = 0;                                                                 // Configure PORT pins as digital
	CLRF        ANSELA+0 
;PICmon8.c,84 :: 		ANSELB = 0;                                                                 // Configure PORT pins as digital
	CLRF        ANSELB+0 
;PICmon8.c,85 :: 		ANSELC = 0;                                                                 // Configure PORT pins as digital
	CLRF        ANSELC+0 
;PICmon8.c,86 :: 		ANSELD = 0;                                                                 // Configure PORT pins as digital
	CLRF        ANSELD+0 
;PICmon8.c,87 :: 		TRISA = 0;
	CLRF        TRISA+0 
;PICmon8.c,88 :: 		TRISB  = 0;                                                                 // Configure PORT as output
	CLRF        TRISB+0 
;PICmon8.c,89 :: 		TRISC  = 0;                                                                 // Configure PORT as output
	CLRF        TRISC+0 
;PICmon8.c,90 :: 		TRISD  = 0;                                                                 // Configure PORT as output
	CLRF        TRISD+0 
;PICmon8.c,91 :: 		LATA = 0;
	CLRF        LATA+0 
;PICmon8.c,92 :: 		LATB = 0x00;                                                                // clear all to Low
	CLRF        LATB+0 
;PICmon8.c,93 :: 		LATC = 0x00;                                                                // clear all to Low
	CLRF        LATC+0 
;PICmon8.c,94 :: 		LATD = 0x00;                                                                // clear all to Low
	CLRF        LATD+0 
;PICmon8.c,97 :: 		UART2_Init(31250);                                                          // Initialize UART 2 module for midi
	MOVLW       255
	MOVWF       U2BRG+0 
	MOVLW       0
	MOVWF       U2BRG+1 
	BSF         U2CON0+0, 7, 0
	CALL        _UART2_Init+0, 0
;PICmon8.c,98 :: 		UART1_Init(115200);                                                         // Initialize UART 1 module at least 3x MIDI rate
	MOVLW       68
	MOVWF       U1BRG+0 
	MOVLW       0
	MOVWF       U1BRG+1 
	BSF         U1CON0+0, 7, 0
	CALL        _UART1_Init+0, 0
;PICmon8.c,99 :: 		Delay_ms(100);                                                              // Wait for UART modules to stabilize
	MOVLW       5
	MOVWF       R11, 0
	MOVLW       15
	MOVWF       R12, 0
	MOVLW       241
	MOVWF       R13, 0
L_main1:
	DECFSZ      R13, 1, 1
	BRA         L_main1
	DECFSZ      R12, 1, 1
	BRA         L_main1
	DECFSZ      R11, 1, 1
	BRA         L_main1
;PICmon8.c,100 :: 		newcmd = '?';                                                               // default to help
	MOVLW       63
	MOVWF       _newcmd+0 
;PICmon8.c,101 :: 		cmd = newcmd;
	MOVLW       63
	MOVWF       _cmd+0 
;PICmon8.c,103 :: 		UART1_Write_Text("\r\n\nPICmon8 Monitor 2 Sept 2019\r\n");                     // introduction text
	MOVLW       ?lstr1_PICmon8+0
	MOVWF       FARG_UART1_Write_Text_uart_text+0 
	MOVLW       hi_addr(?lstr1_PICmon8+0)
	MOVWF       FARG_UART1_Write_Text_uart_text+1 
	CALL        _UART1_Write_Text+0, 0
;PICmon8.c,104 :: 		UART1_Write_Text("? for help\r\n");                                         // introduction text
	MOVLW       ?lstr2_PICmon8+0
	MOVWF       FARG_UART1_Write_Text_uart_text+0 
	MOVLW       hi_addr(?lstr2_PICmon8+0)
	MOVWF       FARG_UART1_Write_Text_uart_text+1 
	CALL        _UART1_Write_Text+0, 0
;PICmon8.c,106 :: 		U2RXIE_bit = 1;                                                             // turn ON interrupt on UART1 receive
	BSF         U2RXIE_bit+0, BitPos(U2RXIE_bit+0) 
;PICmon8.c,107 :: 		U2RXIF_bit = 0;                                                             // Clear interrupt flag
	BCF         U2RXIF_bit+0, BitPos(U2RXIF_bit+0) 
;PICmon8.c,108 :: 		GIE_bit   = 1;                                                              // Enable GLOBAL interrupts
	BSF         GIE_bit+0, BitPos(GIE_bit+0) 
;PICmon8.c,110 :: 		while(1){
L_main2:
;PICmon8.c,111 :: 		linein(linebuff);                                                       // fetch a line of text
	MOVLW       _linebuff+0
	MOVWF       FARG_linein_pstring+0 
	MOVLW       hi_addr(_linebuff+0)
	MOVWF       FARG_linein_pstring+1 
	CALL        _linein+0, 0
;PICmon8.c,112 :: 		newcmd = getparams(linebuff);                                           // read hex parameters
	MOVLW       _linebuff+0
	MOVWF       FARG_getparams_tempstring+0 
	MOVLW       hi_addr(_linebuff+0)
	MOVWF       FARG_getparams_tempstring+1 
	CALL        _getparams+0, 0
	MOVF        R0, 0 
	MOVWF       _newcmd+0 
;PICmon8.c,113 :: 		switch(newcmd){                                                         // find command letter
	GOTO        L_main4
;PICmon8.c,114 :: 		case 'F':
L_main6:
;PICmon8.c,115 :: 		cmdf();
	CALL        _cmdf+0, 0
;PICmon8.c,116 :: 		break;
	GOTO        L_main5
;PICmon8.c,118 :: 		case 'O':
L_main7:
;PICmon8.c,119 :: 		cmdo();
	CALL        _cmdo+0, 0
;PICmon8.c,120 :: 		break;
	GOTO        L_main5
;PICmon8.c,122 :: 		case 'P':
L_main8:
;PICmon8.c,123 :: 		cmdp();
	CALL        _cmdp+0, 0
;PICmon8.c,124 :: 		break;
	GOTO        L_main5
;PICmon8.c,126 :: 		case 'R':
L_main9:
;PICmon8.c,127 :: 		cmdr();
	CALL        _cmdr+0, 0
;PICmon8.c,128 :: 		break;
	GOTO        L_main5
;PICmon8.c,130 :: 		case 'W':
L_main10:
;PICmon8.c,131 :: 		cmdw();
	CALL        _cmdw+0, 0
;PICmon8.c,132 :: 		break;
	GOTO        L_main5
;PICmon8.c,134 :: 		case '?':
L_main11:
;PICmon8.c,135 :: 		UART1_Write_Text("?        List Commands\r\n");
	MOVLW       ?lstr3_PICmon8+0
	MOVWF       FARG_UART1_Write_Text_uart_text+0 
	MOVLW       hi_addr(?lstr3_PICmon8+0)
	MOVWF       FARG_UART1_Write_Text_uart_text+1 
	CALL        _UART1_Write_Text+0, 0
;PICmon8.c,136 :: 		UART1_Write_Text("f dd     Fill with dd EEPROM Click mikroBUS1\r\n");
	MOVLW       ?lstr4_PICmon8+0
	MOVWF       FARG_UART1_Write_Text_uart_text+0 
	MOVLW       hi_addr(?lstr4_PICmon8+0)
	MOVWF       FARG_UART1_Write_Text_uart_text+1 
	CALL        _UART1_Write_Text+0, 0
;PICmon8.c,137 :: 		UART1_Write_Text("o cc ..  Output hex to MIDI\r\n");
	MOVLW       ?lstr5_PICmon8+0
	MOVWF       FARG_UART1_Write_Text_uart_text+0 
	MOVLW       hi_addr(?lstr5_PICmon8+0)
	MOVWF       FARG_UART1_Write_Text_uart_text+1 
	CALL        _UART1_Write_Text+0, 0
;PICmon8.c,138 :: 		UART1_Write_Text("p        Parameter test\r\n");
	MOVLW       ?lstr6_PICmon8+0
	MOVWF       FARG_UART1_Write_Text_uart_text+0 
	MOVLW       hi_addr(?lstr6_PICmon8+0)
	MOVWF       FARG_UART1_Write_Text_uart_text+1 
	CALL        _UART1_Write_Text+0, 0
;PICmon8.c,139 :: 		UART1_Write_Text("r        Read EEPROM Click mikroBUS1\r\n");
	MOVLW       ?lstr7_PICmon8+0
	MOVWF       FARG_UART1_Write_Text_uart_text+0 
	MOVLW       hi_addr(?lstr7_PICmon8+0)
	MOVWF       FARG_UART1_Write_Text_uart_text+1 
	CALL        _UART1_Write_Text+0, 0
;PICmon8.c,140 :: 		UART1_Write_Text("w aaa dd Write EEPROM Click mikroBUS1\r\n");
	MOVLW       ?lstr8_PICmon8+0
	MOVWF       FARG_UART1_Write_Text_uart_text+0 
	MOVLW       hi_addr(?lstr8_PICmon8+0)
	MOVWF       FARG_UART1_Write_Text_uart_text+1 
	CALL        _UART1_Write_Text+0, 0
;PICmon8.c,141 :: 		break;
	GOTO        L_main5
;PICmon8.c,143 :: 		default:{
L_main12:
;PICmon8.c,144 :: 		UART1_Write_Text("\r\ncommand not recognised\r\n");
	MOVLW       ?lstr9_PICmon8+0
	MOVWF       FARG_UART1_Write_Text_uart_text+0 
	MOVLW       hi_addr(?lstr9_PICmon8+0)
	MOVWF       FARG_UART1_Write_Text_uart_text+1 
	CALL        _UART1_Write_Text+0, 0
;PICmon8.c,145 :: 		break;
	GOTO        L_main5
;PICmon8.c,147 :: 		}
L_main4:
	MOVF        _newcmd+0, 0 
	XORLW       70
	BTFSC       STATUS+0, 2 
	GOTO        L_main6
	MOVF        _newcmd+0, 0 
	XORLW       79
	BTFSC       STATUS+0, 2 
	GOTO        L_main7
	MOVF        _newcmd+0, 0 
	XORLW       80
	BTFSC       STATUS+0, 2 
	GOTO        L_main8
	MOVF        _newcmd+0, 0 
	XORLW       82
	BTFSC       STATUS+0, 2 
	GOTO        L_main9
	MOVF        _newcmd+0, 0 
	XORLW       87
	BTFSC       STATUS+0, 2 
	GOTO        L_main10
	MOVF        _newcmd+0, 0 
	XORLW       63
	BTFSC       STATUS+0, 2 
	GOTO        L_main11
	GOTO        L_main12
L_main5:
;PICmon8.c,148 :: 		}
	GOTO        L_main2
;PICmon8.c,149 :: 		}
L_end_main:
	GOTO        $+0
; end of _main

_cmdf:

;PICmon8.c,153 :: 		void cmdf(){
;PICmon8.c,155 :: 		e_send[1] = upar[1];
	MOVF        _upar+2, 0 
	MOVWF       _e_send+1 
;PICmon8.c,157 :: 		LATC0_bit = 0;                                                              // WP write enable when low
	BCF         LATC0_bit+0, BitPos(LATC0_bit+0) 
;PICmon8.c,158 :: 		ANSELC0_bit = 0;                                                            // digital
	BCF         ANSELC0_bit+0, BitPos(ANSELC0_bit+0) 
;PICmon8.c,159 :: 		TRISC0_bit = 0;                                                             // output
	BCF         TRISC0_bit+0, BitPos(TRISC0_bit+0) 
;PICmon8.c,160 :: 		UART1_Write_Text("\r\nEEPROM Fill.");
	MOVLW       ?lstr10_PICmon8+0
	MOVWF       FARG_UART1_Write_Text_uart_text+0 
	MOVLW       hi_addr(?lstr10_PICmon8+0)
	MOVWF       FARG_UART1_Write_Text_uart_text+1 
	CALL        _UART1_Write_Text+0, 0
;PICmon8.c,162 :: 		I2C1_Init();                                                                // initialize I2C communication
	CALL        _I2C1_Init+0, 0
;PICmon8.c,164 :: 		Delay_ms(100);
	MOVLW       5
	MOVWF       R11, 0
	MOVLW       15
	MOVWF       R12, 0
	MOVLW       241
	MOVWF       R13, 0
L_cmdf13:
	DECFSZ      R13, 1, 1
	BRA         L_cmdf13
	DECFSZ      R12, 1, 1
	BRA         L_cmdf13
	DECFSZ      R11, 1, 1
	BRA         L_cmdf13
;PICmon8.c,166 :: 		if(nparams == 2){
	MOVF        _nparams+0, 0 
	XORLW       2
	BTFSS       STATUS+0, 2 
	GOTO        L_cmdf14
;PICmon8.c,167 :: 		for(ee_addr = 0; ee_addr < 1024; ee_addr++){
	CLRF        _ee_addr+0 
	CLRF        _ee_addr+1 
L_cmdf15:
	MOVLW       4
	SUBWF       _ee_addr+1, 0 
	BTFSS       STATUS+0, 2 
	GOTO        L__cmdf114
	MOVLW       0
	SUBWF       _ee_addr+0, 0 
L__cmdf114:
	BTFSC       STATUS+0, 0 
	GOTO        L_cmdf16
;PICmon8.c,168 :: 		EC_tmp = (ee_addr >> 8) & 0x03;                                     // get top 2 address bits
	MOVF        _ee_addr+1, 0 
	MOVWF       R0 
	CLRF        R1 
	MOVLW       3
	ANDWF       R0, 0 
	MOVWF       R0 
	MOVF        R0, 0 
	MOVWF       _EC_tmp+0 
;PICmon8.c,169 :: 		EC_hdr = 0x50 + EC_tmp;                                             // bare EEPROM i2c address + hi 2 bits EEPROM aggress
	MOVLW       80
	ADDWF       R0, 1 
	MOVF        R0, 0 
	MOVWF       _EC_hdr+0 
;PICmon8.c,170 :: 		e_send[0]= ee_addr & 0x0ff;
	MOVLW       255
	ANDWF       _ee_addr+0, 0 
	MOVWF       _e_send+0 
;PICmon8.c,171 :: 		I2C1_Wr(EC_hdr, &e_send, 2, _I2C_END_MODE_STOP);                    // write byte
	MOVF        R0, 0 
	MOVWF       FARG_I2C1_Wr_slave_address+0 
	MOVLW       _e_send+0
	MOVWF       FARG_I2C1_Wr_ptrdata+0 
	MOVLW       hi_addr(_e_send+0)
	MOVWF       FARG_I2C1_Wr_ptrdata+1 
	MOVLW       2
	MOVWF       FARG_I2C1_Wr_count+0 
	CLRF        FARG_I2C1_Wr_END_mode+0 
	CALL        _I2C1_Wr+0, 0
;PICmon8.c,172 :: 		Delay_ms(5);                                                        // do not try to write faster than EEPROM can hamdle
	MOVLW       52
	MOVWF       R12, 0
	MOVLW       241
	MOVWF       R13, 0
L_cmdf18:
	DECFSZ      R13, 1, 1
	BRA         L_cmdf18
	DECFSZ      R12, 1, 1
	BRA         L_cmdf18
	NOP
	NOP
;PICmon8.c,173 :: 		if((ee_addr & 0x1f) == 0){
	MOVLW       31
	ANDWF       _ee_addr+0, 0 
	MOVWF       R1 
	MOVF        _ee_addr+1, 0 
	MOVWF       R2 
	MOVLW       0
	ANDWF       R2, 1 
	MOVLW       0
	XORWF       R2, 0 
	BTFSS       STATUS+0, 2 
	GOTO        L__cmdf115
	MOVLW       0
	XORWF       R1, 0 
L__cmdf115:
	BTFSS       STATUS+0, 2 
	GOTO        L_cmdf19
;PICmon8.c,174 :: 		UART1_Write_Text(".");
	MOVLW       ?lstr11_PICmon8+0
	MOVWF       FARG_UART1_Write_Text_uart_text+0 
	MOVLW       hi_addr(?lstr11_PICmon8+0)
	MOVWF       FARG_UART1_Write_Text_uart_text+1 
	CALL        _UART1_Write_Text+0, 0
;PICmon8.c,175 :: 		}
L_cmdf19:
;PICmon8.c,167 :: 		for(ee_addr = 0; ee_addr < 1024; ee_addr++){
	INFSNZ      _ee_addr+0, 1 
	INCF        _ee_addr+1, 1 
;PICmon8.c,176 :: 		}
	GOTO        L_cmdf15
L_cmdf16:
;PICmon8.c,177 :: 		}
	GOTO        L_cmdf20
L_cmdf14:
;PICmon8.c,179 :: 		UART1_Write_Text("syntax error - need...\r\nf dd\r\n");
	MOVLW       ?lstr12_PICmon8+0
	MOVWF       FARG_UART1_Write_Text_uart_text+0 
	MOVLW       hi_addr(?lstr12_PICmon8+0)
	MOVWF       FARG_UART1_Write_Text_uart_text+1 
	CALL        _UART1_Write_Text+0, 0
;PICmon8.c,180 :: 		}
L_cmdf20:
;PICmon8.c,181 :: 		LATC0_bit = 1;                                                              // WP write protect when high
	BSF         LATC0_bit+0, BitPos(LATC0_bit+0) 
;PICmon8.c,182 :: 		UART1_Write_Text("\r\ndone\r\n");
	MOVLW       ?lstr13_PICmon8+0
	MOVWF       FARG_UART1_Write_Text_uart_text+0 
	MOVLW       hi_addr(?lstr13_PICmon8+0)
	MOVWF       FARG_UART1_Write_Text_uart_text+1 
	CALL        _UART1_Write_Text+0, 0
;PICmon8.c,183 :: 		}
L_end_cmdf:
	RETURN      0
; end of _cmdf

_cmdo:

;PICmon8.c,187 :: 		void cmdo(){
;PICmon8.c,190 :: 		UART1_Write_Text("MIDI out ");
	MOVLW       ?lstr14_PICmon8+0
	MOVWF       FARG_UART1_Write_Text_uart_text+0 
	MOVLW       hi_addr(?lstr14_PICmon8+0)
	MOVWF       FARG_UART1_Write_Text_uart_text+1 
	CALL        _UART1_Write_Text+0, 0
;PICmon8.c,191 :: 		for(pc = 1; pc < nparams; pc++){
	MOVLW       1
	MOVWF       cmdo_pc_L0+0 
L_cmdo21:
	MOVF        _nparams+0, 0 
	SUBWF       cmdo_pc_L0+0, 0 
	BTFSC       STATUS+0, 0 
	GOTO        L_cmdo22
;PICmon8.c,192 :: 		UART2_Write(upar[pc]);
	MOVF        cmdo_pc_L0+0, 0 
	MOVWF       R0 
	MOVLW       0
	MOVWF       R1 
	RLCF        R0, 1 
	BCF         R0, 0 
	RLCF        R1, 1 
	MOVLW       _upar+0
	ADDWF       R0, 0 
	MOVWF       FSR0L+0 
	MOVLW       hi_addr(_upar+0)
	ADDWFC      R1, 0 
	MOVWF       FSR0L+1 
	MOVF        POSTINC0+0, 0 
	MOVWF       FARG_UART2_Write_data_+0 
	CALL        _UART2_Write+0, 0
;PICmon8.c,193 :: 		PrintHexSp(upar[pc]);
	MOVF        cmdo_pc_L0+0, 0 
	MOVWF       R0 
	MOVLW       0
	MOVWF       R1 
	RLCF        R0, 1 
	BCF         R0, 0 
	RLCF        R1, 1 
	MOVLW       _upar+0
	ADDWF       R0, 0 
	MOVWF       FSR0L+0 
	MOVLW       hi_addr(_upar+0)
	ADDWFC      R1, 0 
	MOVWF       FSR0L+1 
	MOVF        POSTINC0+0, 0 
	MOVWF       FARG_PrintHexSp_i+0 
	CALL        _PrintHexSp+0, 0
;PICmon8.c,191 :: 		for(pc = 1; pc < nparams; pc++){
	INCF        cmdo_pc_L0+0, 1 
;PICmon8.c,194 :: 		}
	GOTO        L_cmdo21
L_cmdo22:
;PICmon8.c,195 :: 		UART1_Write_Text("\r\n");
	MOVLW       ?lstr15_PICmon8+0
	MOVWF       FARG_UART1_Write_Text_uart_text+0 
	MOVLW       hi_addr(?lstr15_PICmon8+0)
	MOVWF       FARG_UART1_Write_Text_uart_text+1 
	CALL        _UART1_Write_Text+0, 0
;PICmon8.c,196 :: 		}
L_end_cmdo:
	RETURN      0
; end of _cmdo

_cmdp:

;PICmon8.c,198 :: 		void cmdp(){
;PICmon8.c,200 :: 		PrintHex(nparams);
	MOVF        _nparams+0, 0 
	MOVWF       FARG_PrintHex_i+0 
	CALL        _PrintHex+0, 0
;PICmon8.c,201 :: 		UART1_Write_Text(" parameters\r\n");
	MOVLW       ?lstr16_PICmon8+0
	MOVWF       FARG_UART1_Write_Text_uart_text+0 
	MOVLW       hi_addr(?lstr16_PICmon8+0)
	MOVWF       FARG_UART1_Write_Text_uart_text+1 
	CALL        _UART1_Write_Text+0, 0
;PICmon8.c,202 :: 		Delay_ms(100);                                                              // do not know why this is needed :(
	MOVLW       5
	MOVWF       R11, 0
	MOVLW       15
	MOVWF       R12, 0
	MOVLW       241
	MOVWF       R13, 0
L_cmdp24:
	DECFSZ      R13, 1, 1
	BRA         L_cmdp24
	DECFSZ      R12, 1, 1
	BRA         L_cmdp24
	DECFSZ      R11, 1, 1
	BRA         L_cmdp24
;PICmon8.c,203 :: 		for( paramcount = 0 ; paramcount < 8 ; paramcount++ ){
	CLRF        cmdp_paramcount_L0+0 
L_cmdp25:
	MOVLW       8
	SUBWF       cmdp_paramcount_L0+0, 0 
	BTFSC       STATUS+0, 0 
	GOTO        L_cmdp26
;PICmon8.c,204 :: 		UART1_Write_Text("parameter ");
	MOVLW       ?lstr17_PICmon8+0
	MOVWF       FARG_UART1_Write_Text_uart_text+0 
	MOVLW       hi_addr(?lstr17_PICmon8+0)
	MOVWF       FARG_UART1_Write_Text_uart_text+1 
	CALL        _UART1_Write_Text+0, 0
;PICmon8.c,205 :: 		PrintHexSp(paramcount);
	MOVF        cmdp_paramcount_L0+0, 0 
	MOVWF       FARG_PrintHexSp_i+0 
	CALL        _PrintHexSp+0, 0
;PICmon8.c,206 :: 		PrintHex((upar[paramcount] >> 8) & 0xff);
	MOVF        cmdp_paramcount_L0+0, 0 
	MOVWF       R0 
	MOVLW       0
	MOVWF       R1 
	RLCF        R0, 1 
	BCF         R0, 0 
	RLCF        R1, 1 
	MOVLW       _upar+0
	ADDWF       R0, 0 
	MOVWF       FSR0L+0 
	MOVLW       hi_addr(_upar+0)
	ADDWFC      R1, 0 
	MOVWF       FSR0L+1 
	MOVF        POSTINC0+0, 0 
	MOVWF       R3 
	MOVF        POSTINC0+0, 0 
	MOVWF       R4 
	MOVF        R4, 0 
	MOVWF       R0 
	CLRF        R1 
	MOVLW       255
	ANDWF       R0, 0 
	MOVWF       FARG_PrintHex_i+0 
	CALL        _PrintHex+0, 0
;PICmon8.c,207 :: 		PrintHex((upar[paramcount]) & 0xff);
	MOVF        cmdp_paramcount_L0+0, 0 
	MOVWF       R0 
	MOVLW       0
	MOVWF       R1 
	RLCF        R0, 1 
	BCF         R0, 0 
	RLCF        R1, 1 
	MOVLW       _upar+0
	ADDWF       R0, 0 
	MOVWF       FSR0L+0 
	MOVLW       hi_addr(_upar+0)
	ADDWFC      R1, 0 
	MOVWF       FSR0L+1 
	MOVLW       255
	ANDWF       POSTINC0+0, 0 
	MOVWF       FARG_PrintHex_i+0 
	CALL        _PrintHex+0, 0
;PICmon8.c,208 :: 		UART1_Write_Text("\r\n");
	MOVLW       ?lstr18_PICmon8+0
	MOVWF       FARG_UART1_Write_Text_uart_text+0 
	MOVLW       hi_addr(?lstr18_PICmon8+0)
	MOVWF       FARG_UART1_Write_Text_uart_text+1 
	CALL        _UART1_Write_Text+0, 0
;PICmon8.c,203 :: 		for( paramcount = 0 ; paramcount < 8 ; paramcount++ ){
	INCF        cmdp_paramcount_L0+0, 1 
;PICmon8.c,209 :: 		}
	GOTO        L_cmdp25
L_cmdp26:
;PICmon8.c,210 :: 		}
L_end_cmdp:
	RETURN      0
; end of _cmdp

_cmdr:

;PICmon8.c,213 :: 		void cmdr(){
;PICmon8.c,215 :: 		LATC0_bit = 1;                                                              // WP write protect when high
	BSF         LATC0_bit+0, BitPos(LATC0_bit+0) 
;PICmon8.c,216 :: 		ANSELC0_bit = 0;                                                            // digital
	BCF         ANSELC0_bit+0, BitPos(ANSELC0_bit+0) 
;PICmon8.c,217 :: 		TRISC0_bit = 0;                                                             // output
	BCF         TRISC0_bit+0, BitPos(TRISC0_bit+0) 
;PICmon8.c,218 :: 		UART1_Write_Text("\r\nEEPROM Contents...");
	MOVLW       ?lstr19_PICmon8+0
	MOVWF       FARG_UART1_Write_Text_uart_text+0 
	MOVLW       hi_addr(?lstr19_PICmon8+0)
	MOVWF       FARG_UART1_Write_Text_uart_text+1 
	CALL        _UART1_Write_Text+0, 0
;PICmon8.c,220 :: 		I2C1_Init();                                                                // initialize I2C communication
	CALL        _I2C1_Init+0, 0
;PICmon8.c,221 :: 		Delay_ms(100);
	MOVLW       5
	MOVWF       R11, 0
	MOVLW       15
	MOVWF       R12, 0
	MOVLW       241
	MOVWF       R13, 0
L_cmdr28:
	DECFSZ      R13, 1, 1
	BRA         L_cmdr28
	DECFSZ      R12, 1, 1
	BRA         L_cmdr28
	DECFSZ      R11, 1, 1
	BRA         L_cmdr28
;PICmon8.c,223 :: 		for(EC_adr = 0; EC_adr < 1024; EC_adr++){                                   // 1k bytes in EEPROM
	CLRF        _EC_adr+0 
	CLRF        _EC_adr+1 
L_cmdr29:
	MOVLW       4
	SUBWF       _EC_adr+1, 0 
	BTFSS       STATUS+0, 2 
	GOTO        L__cmdr119
	MOVLW       0
	SUBWF       _EC_adr+0, 0 
L__cmdr119:
	BTFSC       STATUS+0, 0 
	GOTO        L_cmdr30
;PICmon8.c,224 :: 		if(! (EC_adr & 0x0f)){                                                  // show address every 16th byte
	MOVLW       15
	ANDWF       _EC_adr+0, 0 
	MOVWF       R0 
	MOVF        _EC_adr+1, 0 
	MOVWF       R1 
	MOVLW       0
	ANDWF       R1, 1 
	MOVF        R0, 0 
	IORWF       R1, 0 
	BTFSS       STATUS+0, 2 
	GOTO        L_cmdr32
;PICmon8.c,225 :: 		UART1_Write_Text("\r\n");
	MOVLW       ?lstr20_PICmon8+0
	MOVWF       FARG_UART1_Write_Text_uart_text+0 
	MOVLW       hi_addr(?lstr20_PICmon8+0)
	MOVWF       FARG_UART1_Write_Text_uart_text+1 
	CALL        _UART1_Write_Text+0, 0
;PICmon8.c,226 :: 		PrintHex(EC_adr/256);
	MOVF        _EC_adr+1, 0 
	MOVWF       R0 
	CLRF        R1 
	MOVF        R0, 0 
	MOVWF       FARG_PrintHex_i+0 
	CALL        _PrintHex+0, 0
;PICmon8.c,227 :: 		PrintHex(EC_adr);
	MOVF        _EC_adr+0, 0 
	MOVWF       FARG_PrintHex_i+0 
	CALL        _PrintHex+0, 0
;PICmon8.c,228 :: 		UART1_Write_Text(" = ");
	MOVLW       ?lstr21_PICmon8+0
	MOVWF       FARG_UART1_Write_Text_uart_text+0 
	MOVLW       hi_addr(?lstr21_PICmon8+0)
	MOVWF       FARG_UART1_Write_Text_uart_text+1 
	CALL        _UART1_Write_Text+0, 0
;PICmon8.c,229 :: 		}
	GOTO        L_cmdr33
L_cmdr32:
;PICmon8.c,231 :: 		if(! (EC_adr & 0x03)){                                              // show address every 16th byte
	MOVLW       3
	ANDWF       _EC_adr+0, 0 
	MOVWF       R0 
	MOVF        _EC_adr+1, 0 
	MOVWF       R1 
	MOVLW       0
	ANDWF       R1, 1 
	MOVF        R0, 0 
	IORWF       R1, 0 
	BTFSS       STATUS+0, 2 
	GOTO        L_cmdr34
;PICmon8.c,232 :: 		UART1_Write_Text("- ");
	MOVLW       ?lstr22_PICmon8+0
	MOVWF       FARG_UART1_Write_Text_uart_text+0 
	MOVLW       hi_addr(?lstr22_PICmon8+0)
	MOVWF       FARG_UART1_Write_Text_uart_text+1 
	CALL        _UART1_Write_Text+0, 0
;PICmon8.c,233 :: 		}
L_cmdr34:
;PICmon8.c,234 :: 		}
L_cmdr33:
;PICmon8.c,235 :: 		EC_tmp = (EC_adr >> 8) & 0x03;                                          // get top 2 address bits
	MOVF        _EC_adr+1, 0 
	MOVWF       R0 
	CLRF        R1 
	MOVLW       3
	ANDWF       R0, 0 
	MOVWF       R0 
	MOVF        R0, 0 
	MOVWF       _EC_tmp+0 
;PICmon8.c,236 :: 		EC_hdr = 0x50 + EC_tmp;                                                 // bare EEPROM i2c address + hi 2 bits EEPROM aggress
	MOVLW       80
	ADDWF       R0, 1 
	MOVF        R0, 0 
	MOVWF       _EC_hdr+0 
;PICmon8.c,237 :: 		I2C1_Wr(EC_hdr, &EC_adr, 1, _I2C_END_MODE_RESTART);                     // send byte (data address)
	MOVF        R0, 0 
	MOVWF       FARG_I2C1_Wr_slave_address+0 
	MOVLW       _EC_adr+0
	MOVWF       FARG_I2C1_Wr_ptrdata+0 
	MOVLW       hi_addr(_EC_adr+0)
	MOVWF       FARG_I2C1_Wr_ptrdata+1 
	MOVLW       1
	MOVWF       FARG_I2C1_Wr_count+0 
	MOVLW       1
	MOVWF       FARG_I2C1_Wr_END_mode+0 
	CALL        _I2C1_Wr+0, 0
;PICmon8.c,238 :: 		I2C1_Rd(EC_hdr, &EC_data, 1, _I2C_END_MODE_STOP);                       // send byte (device address + R)
	MOVF        _EC_hdr+0, 0 
	MOVWF       FARG_I2C1_Rd_slave_address+0 
	MOVLW       _EC_data+0
	MOVWF       FARG_I2C1_Rd_ptrdata+0 
	MOVLW       hi_addr(_EC_data+0)
	MOVWF       FARG_I2C1_Rd_ptrdata+1 
	MOVLW       1
	MOVWF       FARG_I2C1_Rd_count+0 
	CLRF        FARG_I2C1_Rd_END_mode+0 
	CALL        _I2C1_Rd+0, 0
;PICmon8.c,239 :: 		PrintHexSp(EC_data);
	MOVF        _EC_data+0, 0 
	MOVWF       FARG_PrintHexSp_i+0 
	CALL        _PrintHexSp+0, 0
;PICmon8.c,240 :: 		Delay_ms(1);                                                            // slow down the display rate
	MOVLW       11
	MOVWF       R12, 0
	MOVLW       98
	MOVWF       R13, 0
L_cmdr35:
	DECFSZ      R13, 1, 1
	BRA         L_cmdr35
	DECFSZ      R12, 1, 1
	BRA         L_cmdr35
	NOP
;PICmon8.c,223 :: 		for(EC_adr = 0; EC_adr < 1024; EC_adr++){                                   // 1k bytes in EEPROM
	INFSNZ      _EC_adr+0, 1 
	INCF        _EC_adr+1, 1 
;PICmon8.c,241 :: 		}
	GOTO        L_cmdr29
L_cmdr30:
;PICmon8.c,242 :: 		UART1_Write_Text("\r\n");
	MOVLW       ?lstr23_PICmon8+0
	MOVWF       FARG_UART1_Write_Text_uart_text+0 
	MOVLW       hi_addr(?lstr23_PICmon8+0)
	MOVWF       FARG_UART1_Write_Text_uart_text+1 
	CALL        _UART1_Write_Text+0, 0
;PICmon8.c,243 :: 		}
L_end_cmdr:
	RETURN      0
; end of _cmdr

_cmdw:

;PICmon8.c,247 :: 		void cmdw(){
;PICmon8.c,249 :: 		e_send[0] = upar[1];
	MOVF        _upar+2, 0 
	MOVWF       _e_send+0 
;PICmon8.c,250 :: 		e_send[1] = upar[2];
	MOVF        _upar+4, 0 
	MOVWF       _e_send+1 
;PICmon8.c,252 :: 		LATC0_bit = 0;                                                              // WP write enable when low
	BCF         LATC0_bit+0, BitPos(LATC0_bit+0) 
;PICmon8.c,253 :: 		ANSELC0_bit = 0;                                                            // digital
	BCF         ANSELC0_bit+0, BitPos(ANSELC0_bit+0) 
;PICmon8.c,254 :: 		TRISC0_bit = 0;                                                             // output
	BCF         TRISC0_bit+0, BitPos(TRISC0_bit+0) 
;PICmon8.c,255 :: 		UART1_Write_Text("\r\nEEPROM Write...");
	MOVLW       ?lstr24_PICmon8+0
	MOVWF       FARG_UART1_Write_Text_uart_text+0 
	MOVLW       hi_addr(?lstr24_PICmon8+0)
	MOVWF       FARG_UART1_Write_Text_uart_text+1 
	CALL        _UART1_Write_Text+0, 0
;PICmon8.c,257 :: 		I2C1_Init();                                                                // initialize I2C communication
	CALL        _I2C1_Init+0, 0
;PICmon8.c,259 :: 		Delay_ms(100);
	MOVLW       5
	MOVWF       R11, 0
	MOVLW       15
	MOVWF       R12, 0
	MOVLW       241
	MOVWF       R13, 0
L_cmdw36:
	DECFSZ      R13, 1, 1
	BRA         L_cmdw36
	DECFSZ      R12, 1, 1
	BRA         L_cmdw36
	DECFSZ      R11, 1, 1
	BRA         L_cmdw36
;PICmon8.c,261 :: 		if(nparams == 3){
	MOVF        _nparams+0, 0 
	XORLW       3
	BTFSS       STATUS+0, 2 
	GOTO        L_cmdw37
;PICmon8.c,262 :: 		EC_tmp = (upar[1] + 3) & 0x03;                                          // get top 2 address bits
	MOVLW       3
	ADDWF       _upar+2, 0 
	MOVWF       R0 
	MOVLW       3
	ANDWF       R0, 1 
	MOVF        R0, 0 
	MOVWF       _EC_tmp+0 
;PICmon8.c,263 :: 		EC_hdr = 0x50 + EC_tmp;                                                 // bare EEPROM i2c address + hi 2 bits EEPROM aggress
	MOVLW       80
	ADDWF       R0, 1 
	MOVF        R0, 0 
	MOVWF       _EC_hdr+0 
;PICmon8.c,264 :: 		I2C1_Wr(EC_hdr, &e_send, 2, _I2C_END_MODE_STOP);                        // write byte
	MOVF        R0, 0 
	MOVWF       FARG_I2C1_Wr_slave_address+0 
	MOVLW       _e_send+0
	MOVWF       FARG_I2C1_Wr_ptrdata+0 
	MOVLW       hi_addr(_e_send+0)
	MOVWF       FARG_I2C1_Wr_ptrdata+1 
	MOVLW       2
	MOVWF       FARG_I2C1_Wr_count+0 
	CLRF        FARG_I2C1_Wr_END_mode+0 
	CALL        _I2C1_Wr+0, 0
;PICmon8.c,266 :: 		}
	GOTO        L_cmdw38
L_cmdw37:
;PICmon8.c,268 :: 		UART1_Write_Text("syntax error - need...\r\nw aaa dd\r\n");
	MOVLW       ?lstr25_PICmon8+0
	MOVWF       FARG_UART1_Write_Text_uart_text+0 
	MOVLW       hi_addr(?lstr25_PICmon8+0)
	MOVWF       FARG_UART1_Write_Text_uart_text+1 
	CALL        _UART1_Write_Text+0, 0
;PICmon8.c,269 :: 		}
L_cmdw38:
;PICmon8.c,270 :: 		LATC0_bit = 1;                                                              // WP write protect when high
	BSF         LATC0_bit+0, BitPos(LATC0_bit+0) 
;PICmon8.c,271 :: 		UART1_Write_Text("\r\n");
	MOVLW       ?lstr26_PICmon8+0
	MOVWF       FARG_UART1_Write_Text_uart_text+0 
	MOVLW       hi_addr(?lstr26_PICmon8+0)
	MOVWF       FARG_UART1_Write_Text_uart_text+1 
	CALL        _UART1_Write_Text+0, 0
;PICmon8.c,272 :: 		}
L_end_cmdw:
	RETURN      0
; end of _cmdw

_PrintHex:

;PICmon8.c,275 :: 		void PrintHex(unsigned char i) {
;PICmon8.c,278 :: 		hi = i & 0xF0;                                                              // high nibble
	MOVLW       240
	ANDWF       FARG_PrintHex_i+0, 0 
	MOVWF       R2 
	MOVF        R2, 0 
	MOVWF       PrintHex_hi_L0+0 
;PICmon8.c,279 :: 		hi = hi >> 4;
	MOVF        R2, 0 
	MOVWF       R0 
	RRCF        R0, 1 
	BCF         R0, 7 
	RRCF        R0, 1 
	BCF         R0, 7 
	RRCF        R0, 1 
	BCF         R0, 7 
	RRCF        R0, 1 
	BCF         R0, 7 
	MOVF        R0, 0 
	MOVWF       PrintHex_hi_L0+0 
;PICmon8.c,280 :: 		hi = hi + '0';
	MOVLW       48
	ADDWF       R0, 0 
	MOVWF       R1 
	MOVF        R1, 0 
	MOVWF       PrintHex_hi_L0+0 
;PICmon8.c,281 :: 		if (hi > '9') hi = hi + 7;
	MOVF        R1, 0 
	SUBLW       57
	BTFSC       STATUS+0, 0 
	GOTO        L_PrintHex39
	MOVLW       7
	ADDWF       PrintHex_hi_L0+0, 1 
L_PrintHex39:
;PICmon8.c,282 :: 		lo = (i & 0x0F) + '0';                                                      // low nibble
	MOVLW       15
	ANDWF       FARG_PrintHex_i+0, 0 
	MOVWF       R0 
	MOVLW       48
	ADDWF       R0, 0 
	MOVWF       R1 
	MOVF        R1, 0 
	MOVWF       PrintHex_lo_L0+0 
;PICmon8.c,283 :: 		if (lo>'9') lo=lo+7;
	MOVF        R1, 0 
	SUBLW       57
	BTFSC       STATUS+0, 0 
	GOTO        L_PrintHex40
	MOVLW       7
	ADDWF       PrintHex_lo_L0+0, 1 
L_PrintHex40:
;PICmon8.c,285 :: 		UART1_Write(hi);
	MOVF        PrintHex_hi_L0+0, 0 
	MOVWF       FARG_UART1_Write_data_+0 
	CALL        _UART1_Write+0, 0
;PICmon8.c,286 :: 		UART1_Write(lo);
	MOVF        PrintHex_lo_L0+0, 0 
	MOVWF       FARG_UART1_Write_data_+0 
	CALL        _UART1_Write+0, 0
;PICmon8.c,287 :: 		}
L_end_PrintHex:
	RETURN      0
; end of _PrintHex

_PrintHexSp:

;PICmon8.c,290 :: 		void PrintHexSp(unsigned char i) {
;PICmon8.c,293 :: 		hi = i & 0xF0;                                                              // high nibble
	MOVLW       240
	ANDWF       FARG_PrintHexSp_i+0, 0 
	MOVWF       R2 
	MOVF        R2, 0 
	MOVWF       PrintHexSp_hi_L0+0 
;PICmon8.c,294 :: 		hi = hi >> 4;
	MOVF        R2, 0 
	MOVWF       R0 
	RRCF        R0, 1 
	BCF         R0, 7 
	RRCF        R0, 1 
	BCF         R0, 7 
	RRCF        R0, 1 
	BCF         R0, 7 
	RRCF        R0, 1 
	BCF         R0, 7 
	MOVF        R0, 0 
	MOVWF       PrintHexSp_hi_L0+0 
;PICmon8.c,295 :: 		hi = hi + '0';
	MOVLW       48
	ADDWF       R0, 0 
	MOVWF       R1 
	MOVF        R1, 0 
	MOVWF       PrintHexSp_hi_L0+0 
;PICmon8.c,296 :: 		if (hi > '9') hi = hi + 7;
	MOVF        R1, 0 
	SUBLW       57
	BTFSC       STATUS+0, 0 
	GOTO        L_PrintHexSp41
	MOVLW       7
	ADDWF       PrintHexSp_hi_L0+0, 1 
L_PrintHexSp41:
;PICmon8.c,297 :: 		lo = (i & 0x0F) + '0';                                                      // low nibble
	MOVLW       15
	ANDWF       FARG_PrintHexSp_i+0, 0 
	MOVWF       R0 
	MOVLW       48
	ADDWF       R0, 0 
	MOVWF       R1 
	MOVF        R1, 0 
	MOVWF       PrintHexSp_lo_L0+0 
;PICmon8.c,298 :: 		if (lo>'9') lo=lo+7;
	MOVF        R1, 0 
	SUBLW       57
	BTFSC       STATUS+0, 0 
	GOTO        L_PrintHexSp42
	MOVLW       7
	ADDWF       PrintHexSp_lo_L0+0, 1 
L_PrintHexSp42:
;PICmon8.c,300 :: 		UART1_Write(hi);
	MOVF        PrintHexSp_hi_L0+0, 0 
	MOVWF       FARG_UART1_Write_data_+0 
	CALL        _UART1_Write+0, 0
;PICmon8.c,301 :: 		UART1_Write(lo);
	MOVF        PrintHexSp_lo_L0+0, 0 
	MOVWF       FARG_UART1_Write_data_+0 
	CALL        _UART1_Write+0, 0
;PICmon8.c,302 :: 		UART1_Write(' ');
	MOVLW       32
	MOVWF       FARG_UART1_Write_data_+0 
	CALL        _UART1_Write+0, 0
;PICmon8.c,303 :: 		}
L_end_PrintHexSp:
	RETURN      0
; end of _PrintHexSp

_getparams:

;PICmon8.c,306 :: 		char getparams(char* tempstring){
;PICmon8.c,311 :: 		unsigned int         pointer1=0;                                                // pointer within string
	CLRF        getparams_pointer1_L0+0 
	CLRF        getparams_pointer1_L0+1 
	CLRF        getparams_pointer2_L0+0 
	CLRF        getparams_pointer2_L0+1 
;PICmon8.c,314 :: 		oldcmd=cmd;                                                                 // remember old value
	MOVF        _cmd+0, 0 
	MOVWF       getparams_oldcmd_L0+0 
;PICmon8.c,315 :: 		nparams = 0;                                                                // initialise
	CLRF        _nparams+0 
;PICmon8.c,316 :: 		pointer1 = 0;                                                               // initialise
	CLRF        getparams_pointer1_L0+0 
	CLRF        getparams_pointer1_L0+1 
;PICmon8.c,318 :: 		for ( n = 0 ; n < 8 ; n++){                                                 // count 0 to 7
	CLRF        getparams_n_L0+0 
	CLRF        getparams_n_L0+1 
L_getparams43:
	MOVLW       128
	XORWF       getparams_n_L0+1, 0 
	MOVWF       R0 
	MOVLW       128
	SUBWF       R0, 0 
	BTFSS       STATUS+0, 2 
	GOTO        L__getparams124
	MOVLW       8
	SUBWF       getparams_n_L0+0, 0 
L__getparams124:
	BTFSC       STATUS+0, 0 
	GOTO        L_getparams44
;PICmon8.c,320 :: 		tempchar=1;                                                             // init
	MOVLW       1
	MOVWF       getparams_tempchar_L0+0 
;PICmon8.c,321 :: 		do {
L_getparams46:
;PICmon8.c,322 :: 		tempchar = tempstring[pointer1++];
	MOVF        getparams_pointer1_L0+0, 0 
	ADDWF       FARG_getparams_tempstring+0, 0 
	MOVWF       FSR0L+0 
	MOVF        getparams_pointer1_L0+1, 0 
	ADDWFC      FARG_getparams_tempstring+1, 0 
	MOVWF       FSR0L+1 
	MOVF        POSTINC0+0, 0 
	MOVWF       R1 
	MOVF        R1, 0 
	MOVWF       getparams_tempchar_L0+0 
	INFSNZ      getparams_pointer1_L0+0, 1 
	INCF        getparams_pointer1_L0+1, 1 
;PICmon8.c,323 :: 		} while (tempchar == 0x20);
	MOVF        R1, 0 
	XORLW       32
	BTFSC       STATUS+0, 2 
	GOTO        L_getparams46
;PICmon8.c,324 :: 		pointer1--;                                                             // leave pointer after param
	MOVLW       1
	SUBWF       getparams_pointer1_L0+0, 1 
	MOVLW       0
	SUBWFB      getparams_pointer1_L0+1, 1 
;PICmon8.c,327 :: 		if ((tempchar != 0) && (nparams < 8)){
	MOVF        getparams_tempchar_L0+0, 0 
	XORLW       0
	BTFSC       STATUS+0, 2 
	GOTO        L_getparams51
	MOVLW       8
	SUBWF       _nparams+0, 0 
	BTFSC       STATUS+0, 0 
	GOTO        L_getparams51
L__getparams109:
;PICmon8.c,328 :: 		nparams++;
	INCF        _nparams+0, 1 
;PICmon8.c,329 :: 		}
L_getparams51:
;PICmon8.c,331 :: 		if (n == 0){                                                            // only for param 0
	MOVLW       0
	XORWF       getparams_n_L0+1, 0 
	BTFSS       STATUS+0, 2 
	GOTO        L__getparams125
	MOVLW       0
	XORWF       getparams_n_L0+0, 0 
L__getparams125:
	BTFSS       STATUS+0, 2 
	GOTO        L_getparams52
;PICmon8.c,332 :: 		tempchar=tempstring[pointer1];                                      // get only first letter
	MOVF        getparams_pointer1_L0+0, 0 
	ADDWF       FARG_getparams_tempstring+0, 0 
	MOVWF       FSR0L+0 
	MOVF        getparams_pointer1_L0+1, 0 
	ADDWFC      FARG_getparams_tempstring+1, 0 
	MOVWF       FSR0L+1 
	MOVF        POSTINC0+0, 0 
	MOVWF       R1 
	MOVF        R1, 0 
	MOVWF       getparams_tempchar_L0+0 
;PICmon8.c,333 :: 		if ((tempchar > 0x60) && (tempchar < 0x7b)) {
	MOVF        R1, 0 
	SUBLW       96
	BTFSC       STATUS+0, 0 
	GOTO        L_getparams55
	MOVLW       123
	SUBWF       getparams_tempchar_L0+0, 0 
	BTFSC       STATUS+0, 0 
	GOTO        L_getparams55
L__getparams108:
;PICmon8.c,334 :: 		tempchar -= 0x20;                                               // to upper case
	MOVLW       32
	SUBWF       getparams_tempchar_L0+0, 1 
;PICmon8.c,335 :: 		}
L_getparams55:
;PICmon8.c,336 :: 		cmd=tempchar;
	MOVF        getparams_tempchar_L0+0, 0 
	MOVWF       _cmd+0 
;PICmon8.c,337 :: 		}
L_getparams52:
;PICmon8.c,339 :: 		tempchar=1;                                                             // initialise
	MOVLW       1
	MOVWF       getparams_tempchar_L0+0 
;PICmon8.c,340 :: 		if (nparams != 0){                                                      // only for non-blank line
	MOVF        _nparams+0, 0 
	XORLW       0
	BTFSC       STATUS+0, 2 
	GOTO        L_getparams56
;PICmon8.c,342 :: 		pointer2=0;                                                         // initialise
	CLRF        getparams_pointer2_L0+0 
	CLRF        getparams_pointer2_L0+1 
;PICmon8.c,343 :: 		do {
L_getparams57:
;PICmon8.c,344 :: 		tempchar = tempstring[pointer1++];                              // get char
	MOVF        getparams_pointer1_L0+0, 0 
	ADDWF       FARG_getparams_tempstring+0, 0 
	MOVWF       FSR0L+0 
	MOVF        getparams_pointer1_L0+1, 0 
	ADDWFC      FARG_getparams_tempstring+1, 0 
	MOVWF       FSR0L+1 
	MOVF        POSTINC0+0, 0 
	MOVWF       R1 
	MOVF        R1, 0 
	MOVWF       getparams_tempchar_L0+0 
	INFSNZ      getparams_pointer1_L0+0, 1 
	INCF        getparams_pointer1_L0+1, 1 
;PICmon8.c,345 :: 		if ((tempchar > 0x60) && (tempchar < 0x7b)) {
	MOVF        R1, 0 
	SUBLW       96
	BTFSC       STATUS+0, 0 
	GOTO        L_getparams62
	MOVLW       123
	SUBWF       getparams_tempchar_L0+0, 0 
	BTFSC       STATUS+0, 0 
	GOTO        L_getparams62
L__getparams107:
;PICmon8.c,346 :: 		tempchar -= 0x20;                                           // to upper case
	MOVLW       32
	SUBWF       getparams_tempchar_L0+0, 1 
;PICmon8.c,347 :: 		}
L_getparams62:
;PICmon8.c,348 :: 		param[n][pointer2++] = tempchar;                                // and store it
	MOVLW       20
	MOVWF       R0 
	MOVLW       0
	MOVWF       R1 
	MOVF        getparams_n_L0+0, 0 
	MOVWF       R4 
	MOVF        getparams_n_L0+1, 0 
	MOVWF       R5 
	CALL        _Mul_16X16_U+0, 0
	MOVLW       _param+0
	ADDWF       R0, 1 
	MOVLW       hi_addr(_param+0)
	ADDWFC      R1, 1 
	MOVF        getparams_pointer2_L0+0, 0 
	ADDWF       R0, 0 
	MOVWF       FSR1L+0 
	MOVF        getparams_pointer2_L0+1, 0 
	ADDWFC      R1, 0 
	MOVWF       FSR1L+1 
	MOVF        getparams_tempchar_L0+0, 0 
	MOVWF       POSTINC1+0 
	INFSNZ      getparams_pointer2_L0+0, 1 
	INCF        getparams_pointer2_L0+1, 1 
;PICmon8.c,349 :: 		} while ((tempchar > 0x20) && (tempchar < 0x7f) && (pointer2 < 20)); // text
	MOVF        getparams_tempchar_L0+0, 0 
	SUBLW       32
	BTFSC       STATUS+0, 0 
	GOTO        L__getparams106
	MOVLW       127
	SUBWF       getparams_tempchar_L0+0, 0 
	BTFSC       STATUS+0, 0 
	GOTO        L__getparams106
	MOVLW       0
	SUBWF       getparams_pointer2_L0+1, 0 
	BTFSS       STATUS+0, 2 
	GOTO        L__getparams126
	MOVLW       20
	SUBWF       getparams_pointer2_L0+0, 0 
L__getparams126:
	BTFSC       STATUS+0, 0 
	GOTO        L__getparams106
	GOTO        L_getparams57
L__getparams106:
;PICmon8.c,350 :: 		param[n][pointer2-1]=0;                                             // zero terminate param string
	MOVLW       20
	MOVWF       R0 
	MOVLW       0
	MOVWF       R1 
	MOVF        getparams_n_L0+0, 0 
	MOVWF       R4 
	MOVF        getparams_n_L0+1, 0 
	MOVWF       R5 
	CALL        _Mul_16X16_U+0, 0
	MOVLW       _param+0
	ADDWF       R0, 0 
	MOVWF       R2 
	MOVLW       hi_addr(_param+0)
	ADDWFC      R1, 0 
	MOVWF       R3 
	MOVLW       1
	SUBWF       getparams_pointer2_L0+0, 0 
	MOVWF       R0 
	MOVLW       0
	SUBWFB      getparams_pointer2_L0+1, 0 
	MOVWF       R1 
	MOVF        R0, 0 
	ADDWF       R2, 0 
	MOVWF       FSR1L+0 
	MOVF        R1, 0 
	ADDWFC      R3, 0 
	MOVWF       FSR1L+1 
	CLRF        POSTINC1+0 
;PICmon8.c,351 :: 		if((tempchar == 0)||(n == 9)){                                      // no more params if end of line
	MOVF        getparams_tempchar_L0+0, 0 
	XORLW       0
	BTFSC       STATUS+0, 2 
	GOTO        L__getparams105
	MOVLW       0
	XORWF       getparams_n_L0+1, 0 
	BTFSS       STATUS+0, 2 
	GOTO        L__getparams127
	MOVLW       9
	XORWF       getparams_n_L0+0, 0 
L__getparams127:
	BTFSC       STATUS+0, 2 
	GOTO        L__getparams105
	GOTO        L_getparams67
L__getparams105:
;PICmon8.c,352 :: 		break;
	GOTO        L_getparams44
;PICmon8.c,353 :: 		}
L_getparams67:
;PICmon8.c,354 :: 		}
L_getparams56:
;PICmon8.c,318 :: 		for ( n = 0 ; n < 8 ; n++){                                                 // count 0 to 7
	INFSNZ      getparams_n_L0+0, 1 
	INCF        getparams_n_L0+1, 1 
;PICmon8.c,355 :: 		}
	GOTO        L_getparams43
L_getparams44:
;PICmon8.c,358 :: 		for (n = 0; n < nparams ; n++){                                             // parms are 0 to 7
	CLRF        getparams_n_L0+0 
	CLRF        getparams_n_L0+1 
L_getparams68:
	MOVLW       128
	XORWF       getparams_n_L0+1, 0 
	MOVWF       R0 
	MOVLW       128
	SUBWF       R0, 0 
	BTFSS       STATUS+0, 2 
	GOTO        L__getparams128
	MOVF        _nparams+0, 0 
	SUBWF       getparams_n_L0+0, 0 
L__getparams128:
	BTFSC       STATUS+0, 0 
	GOTO        L_getparams69
;PICmon8.c,359 :: 		tempchar2=1;                                                            // initialise
	MOVLW       1
	MOVWF       getparams_tempchar2_L0+0 
;PICmon8.c,360 :: 		pointer1=0;                                                             // initialise
	CLRF        getparams_pointer1_L0+0 
	CLRF        getparams_pointer1_L0+1 
;PICmon8.c,361 :: 		upar[n]=0;                                                              // initialise
	MOVF        getparams_n_L0+0, 0 
	MOVWF       R0 
	MOVF        getparams_n_L0+1, 0 
	MOVWF       R1 
	RLCF        R0, 1 
	BCF         R0, 0 
	RLCF        R1, 1 
	MOVLW       _upar+0
	ADDWF       R0, 0 
	MOVWF       FSR1L+0 
	MOVLW       hi_addr(_upar+0)
	ADDWFC      R1, 0 
	MOVWF       FSR1L+1 
	CLRF        POSTINC1+0 
	CLRF        POSTINC1+0 
;PICmon8.c,362 :: 		do {
L_getparams71:
;PICmon8.c,363 :: 		tempchar = param[n][pointer1++];
	MOVLW       20
	MOVWF       R0 
	MOVLW       0
	MOVWF       R1 
	MOVF        getparams_n_L0+0, 0 
	MOVWF       R4 
	MOVF        getparams_n_L0+1, 0 
	MOVWF       R5 
	CALL        _Mul_16X16_U+0, 0
	MOVLW       _param+0
	ADDWF       R0, 1 
	MOVLW       hi_addr(_param+0)
	ADDWFC      R1, 1 
	MOVF        getparams_pointer1_L0+0, 0 
	ADDWF       R0, 0 
	MOVWF       FSR0L+0 
	MOVF        getparams_pointer1_L0+1, 0 
	ADDWFC      R1, 0 
	MOVWF       FSR0L+1 
	MOVF        POSTINC0+0, 0 
	MOVWF       R1 
	MOVF        R1, 0 
	MOVWF       getparams_tempchar_L0+0 
	INFSNZ      getparams_pointer1_L0+0, 1 
	INCF        getparams_pointer1_L0+1, 1 
;PICmon8.c,365 :: 		if ( tempchar != 0 ){
	MOVF        R1, 0 
	XORLW       0
	BTFSC       STATUS+0, 2 
	GOTO        L_getparams74
;PICmon8.c,366 :: 		upar[n] = upar[n] * 0x10;                                       // next most signicant hex digit
	MOVF        getparams_n_L0+0, 0 
	MOVWF       R0 
	MOVF        getparams_n_L0+1, 0 
	MOVWF       R1 
	RLCF        R0, 1 
	BCF         R0, 0 
	RLCF        R1, 1 
	MOVLW       _upar+0
	ADDWF       R0, 0 
	MOVWF       R5 
	MOVLW       hi_addr(_upar+0)
	ADDWFC      R1, 0 
	MOVWF       R6 
	MOVFF       R5, FSR0L+0
	MOVFF       R6, FSR0H+0
	MOVF        POSTINC0+0, 0 
	MOVWF       R3 
	MOVF        POSTINC0+0, 0 
	MOVWF       R4 
	MOVF        R3, 0 
	MOVWF       R0 
	MOVF        R4, 0 
	MOVWF       R1 
	RLCF        R0, 1 
	BCF         R0, 0 
	RLCF        R1, 1 
	RLCF        R0, 1 
	BCF         R0, 0 
	RLCF        R1, 1 
	RLCF        R0, 1 
	BCF         R0, 0 
	RLCF        R1, 1 
	RLCF        R0, 1 
	BCF         R0, 0 
	RLCF        R1, 1 
	MOVFF       R5, FSR1L+0
	MOVFF       R6, FSR1H+0
	MOVF        R0, 0 
	MOVWF       POSTINC1+0 
	MOVF        R1, 0 
	MOVWF       POSTINC1+0 
;PICmon8.c,367 :: 		}            tempchar2=tempchar;
L_getparams74:
	MOVF        getparams_tempchar_L0+0, 0 
	MOVWF       getparams_tempchar2_L0+0 
;PICmon8.c,369 :: 		if ((tempchar < 0x30) || (tempchar > 0x46)) {
	MOVLW       48
	SUBWF       getparams_tempchar_L0+0, 0 
	BTFSS       STATUS+0, 0 
	GOTO        L__getparams104
	MOVF        getparams_tempchar_L0+0, 0 
	SUBLW       70
	BTFSS       STATUS+0, 0 
	GOTO        L__getparams104
	GOTO        L_getparams77
L__getparams104:
;PICmon8.c,370 :: 		tempchar = 0x00;                                                // non-hex to zero
	CLRF        getparams_tempchar_L0+0 
;PICmon8.c,371 :: 		}
L_getparams77:
;PICmon8.c,372 :: 		if ((tempchar > 0x39) && (tempchar < 0x41)) {
	MOVF        getparams_tempchar_L0+0, 0 
	SUBLW       57
	BTFSC       STATUS+0, 0 
	GOTO        L_getparams80
	MOVLW       65
	SUBWF       getparams_tempchar_L0+0, 0 
	BTFSC       STATUS+0, 0 
	GOTO        L_getparams80
L__getparams103:
;PICmon8.c,373 :: 		tempchar = 0x00;                                                // non-hex to zero
	CLRF        getparams_tempchar_L0+0 
;PICmon8.c,374 :: 		}
L_getparams80:
;PICmon8.c,375 :: 		if ((tempchar > 0x40) && (tempchar < 0x47)) {
	MOVF        getparams_tempchar_L0+0, 0 
	SUBLW       64
	BTFSC       STATUS+0, 0 
	GOTO        L_getparams83
	MOVLW       71
	SUBWF       getparams_tempchar_L0+0, 0 
	BTFSC       STATUS+0, 0 
	GOTO        L_getparams83
L__getparams102:
;PICmon8.c,376 :: 		tempchar -= 0x37;                                               // to bin
	MOVLW       55
	SUBWF       getparams_tempchar_L0+0, 1 
;PICmon8.c,377 :: 		}
L_getparams83:
;PICmon8.c,378 :: 		if ((tempchar > 0x2f) && (tempchar < 0x3a)) {
	MOVF        getparams_tempchar_L0+0, 0 
	SUBLW       47
	BTFSC       STATUS+0, 0 
	GOTO        L_getparams86
	MOVLW       58
	SUBWF       getparams_tempchar_L0+0, 0 
	BTFSC       STATUS+0, 0 
	GOTO        L_getparams86
L__getparams101:
;PICmon8.c,379 :: 		tempchar -= 0x30;                                               // to bin
	MOVLW       48
	SUBWF       getparams_tempchar_L0+0, 1 
;PICmon8.c,380 :: 		}
L_getparams86:
;PICmon8.c,381 :: 		upar[n] += tempchar;
	MOVF        getparams_n_L0+0, 0 
	MOVWF       R0 
	MOVF        getparams_n_L0+1, 0 
	MOVWF       R1 
	RLCF        R0, 1 
	BCF         R0, 0 
	RLCF        R1, 1 
	MOVLW       _upar+0
	ADDWF       R0, 0 
	MOVWF       R2 
	MOVLW       hi_addr(_upar+0)
	ADDWFC      R1, 0 
	MOVWF       R3 
	MOVFF       R2, FSR0L+0
	MOVFF       R3, FSR0H+0
	MOVF        getparams_tempchar_L0+0, 0 
	ADDWF       POSTINC0+0, 0 
	MOVWF       R0 
	MOVLW       0
	ADDWFC      POSTINC0+0, 0 
	MOVWF       R1 
	MOVFF       R2, FSR1L+0
	MOVFF       R3, FSR1H+0
	MOVF        R0, 0 
	MOVWF       POSTINC1+0 
	MOVF        R1, 0 
	MOVWF       POSTINC1+0 
;PICmon8.c,382 :: 		} while (tempchar2 != 0);
	MOVF        getparams_tempchar2_L0+0, 0 
	XORLW       0
	BTFSS       STATUS+0, 2 
	GOTO        L_getparams71
;PICmon8.c,358 :: 		for (n = 0; n < nparams ; n++){                                             // parms are 0 to 7
	INFSNZ      getparams_n_L0+0, 1 
	INCF        getparams_n_L0+1, 1 
;PICmon8.c,383 :: 		}
	GOTO        L_getparams68
L_getparams69:
;PICmon8.c,385 :: 		if (nparams == 0) {
	MOVF        _nparams+0, 0 
	XORLW       0
	BTFSS       STATUS+0, 2 
	GOTO        L_getparams87
;PICmon8.c,386 :: 		cmd = oldcmd;
	MOVF        getparams_oldcmd_L0+0, 0 
	MOVWF       _cmd+0 
;PICmon8.c,387 :: 		}
L_getparams87:
;PICmon8.c,388 :: 		return cmd;
	MOVF        _cmd+0, 0 
	MOVWF       R0 
;PICmon8.c,389 :: 		}
L_end_getparams:
	RETURN      0
; end of _getparams

_linein:

;PICmon8.c,395 :: 		void linein(char* pstring){
;PICmon8.c,396 :: 		char inChar = 0;
	CLRF        linein_inChar_L0+0 
;PICmon8.c,398 :: 		while(inChar != '\r'){
L_linein88:
	MOVF        linein_inChar_L0+0, 0 
	XORLW       13
	BTFSC       STATUS+0, 2 
	GOTO        L_linein89
;PICmon8.c,401 :: 		if (UART1_Data_Ready()){
	CALL        _UART1_Data_Ready+0, 0
	MOVF        R0, 1 
	BTFSC       STATUS+0, 2 
	GOTO        L_linein90
;PICmon8.c,402 :: 		inChar = UART1_Read();
	CALL        _UART1_Read+0, 0
	MOVF        R0, 0 
	MOVWF       linein_inChar_L0+0 
;PICmon8.c,403 :: 		UART1_Write(inChar);
	MOVF        R0, 0 
	MOVWF       FARG_UART1_Write_data_+0 
	CALL        _UART1_Write+0, 0
;PICmon8.c,404 :: 		if(inChar == '\r'){
	MOVF        linein_inChar_L0+0, 0 
	XORLW       13
	BTFSS       STATUS+0, 2 
	GOTO        L_linein91
;PICmon8.c,405 :: 		UART1_Write('\n');
	MOVLW       10
	MOVWF       FARG_UART1_Write_data_+0 
	CALL        _UART1_Write+0, 0
;PICmon8.c,406 :: 		*pstring ++= '\0';
	MOVFF       FARG_linein_pstring+0, FSR1L+0
	MOVFF       FARG_linein_pstring+1, FSR1H+0
	CLRF        POSTINC1+0 
	INFSNZ      FARG_linein_pstring+0, 1 
	INCF        FARG_linein_pstring+1, 1 
;PICmon8.c,407 :: 		}
	GOTO        L_linein92
L_linein91:
;PICmon8.c,409 :: 		if (inChar != 0x7f ){                                           // if not backspace
	MOVF        linein_inChar_L0+0, 0 
	XORLW       127
	BTFSC       STATUS+0, 2 
	GOTO        L_linein93
;PICmon8.c,410 :: 		*pstring++ = inChar;
	MOVFF       FARG_linein_pstring+0, FSR1L+0
	MOVFF       FARG_linein_pstring+1, FSR1H+0
	MOVF        linein_inChar_L0+0, 0 
	MOVWF       POSTINC1+0 
	INFSNZ      FARG_linein_pstring+0, 1 
	INCF        FARG_linein_pstring+1, 1 
;PICmon8.c,411 :: 		}
L_linein93:
;PICmon8.c,412 :: 		if (inChar == 0x7f ){                                           // handle backspace
	MOVF        linein_inChar_L0+0, 0 
	XORLW       127
	BTFSS       STATUS+0, 2 
	GOTO        L_linein94
;PICmon8.c,413 :: 		*--pstring = 0x00;
	MOVLW       1
	SUBWF       FARG_linein_pstring+0, 1 
	MOVLW       0
	SUBWFB      FARG_linein_pstring+1, 1 
	MOVFF       FARG_linein_pstring+0, FSR1L+0
	MOVFF       FARG_linein_pstring+1, FSR1H+0
	CLRF        POSTINC1+0 
;PICmon8.c,414 :: 		}
L_linein94:
;PICmon8.c,415 :: 		}
L_linein92:
;PICmon8.c,416 :: 		}
L_linein90:
;PICmon8.c,417 :: 		if(u2_rx_flag){
	MOVF        _u2_rx_flag+0, 1 
	BTFSC       STATUS+0, 2 
	GOTO        L_linein95
;PICmon8.c,418 :: 		u2_rx_flag = 0;
	CLRF        _u2_rx_flag+0 
;PICmon8.c,419 :: 		if(u2_rx_data > 127){
	MOVF        _u2_rx_data+0, 0 
	SUBLW       127
	BTFSC       STATUS+0, 0 
	GOTO        L_linein96
;PICmon8.c,420 :: 		UART1_Write_Text("\r\n");
	MOVLW       ?lstr27_PICmon8+0
	MOVWF       FARG_UART1_Write_Text_uart_text+0 
	MOVLW       hi_addr(?lstr27_PICmon8+0)
	MOVWF       FARG_UART1_Write_Text_uart_text+1 
	CALL        _UART1_Write_Text+0, 0
;PICmon8.c,421 :: 		UART1_Write_Text(int_rx_buf);                                   //
	MOVLW       _int_rx_buf+0
	MOVWF       FARG_UART1_Write_Text_uart_text+0 
	MOVLW       hi_addr(_int_rx_buf+0)
	MOVWF       FARG_UART1_Write_Text_uart_text+1 
	CALL        _UART1_Write_Text+0, 0
;PICmon8.c,422 :: 		}
	GOTO        L_linein97
L_linein96:
;PICmon8.c,424 :: 		UART1_Write_Text("-");
	MOVLW       ?lstr28_PICmon8+0
	MOVWF       FARG_UART1_Write_Text_uart_text+0 
	MOVLW       hi_addr(?lstr28_PICmon8+0)
	MOVWF       FARG_UART1_Write_Text_uart_text+1 
	CALL        _UART1_Write_Text+0, 0
;PICmon8.c,425 :: 		UART1_Write_Text(int_rx_buf);                                   //
	MOVLW       _int_rx_buf+0
	MOVWF       FARG_UART1_Write_Text_uart_text+0 
	MOVLW       hi_addr(_int_rx_buf+0)
	MOVWF       FARG_UART1_Write_Text_uart_text+1 
	CALL        _UART1_Write_Text+0, 0
;PICmon8.c,426 :: 		}
L_linein97:
;PICmon8.c,427 :: 		}
L_linein95:
;PICmon8.c,428 :: 		}
	GOTO        L_linein88
L_linein89:
;PICmon8.c,429 :: 		}
L_end_linein:
	RETURN      0
; end of _linein

_chin:

;PICmon8.c,432 :: 		char chin(void){
;PICmon8.c,435 :: 		while(!UART1_Data_Ready());
L_chin98:
	CALL        _UART1_Data_Ready+0, 0
	MOVF        R0, 1 
	BTFSS       STATUS+0, 2 
	GOTO        L_chin99
	GOTO        L_chin98
L_chin99:
;PICmon8.c,436 :: 		temp = UART1_Read();
	CALL        _UART1_Read+0, 0
;PICmon8.c,437 :: 		return temp;
;PICmon8.c,438 :: 		}
L_end_chin:
	RETURN      0
; end of _chin

_chout:

;PICmon8.c,441 :: 		void chout(char outchar){
;PICmon8.c,443 :: 		UART1_Write(outchar);
	MOVF        FARG_chout_outchar+0, 0 
	MOVWF       FARG_UART1_Write_data_+0 
	CALL        _UART1_Write+0, 0
;PICmon8.c,444 :: 		if(outchar == 0x0d){
	MOVF        FARG_chout_outchar+0, 0 
	XORLW       13
	BTFSS       STATUS+0, 2 
	GOTO        L_chout100
;PICmon8.c,445 :: 		UART1_Write(0x0a);
	MOVLW       10
	MOVWF       FARG_UART1_Write_data_+0 
	CALL        _UART1_Write+0, 0
;PICmon8.c,446 :: 		}
L_chout100:
;PICmon8.c,447 :: 		}
L_end_chout:
	RETURN      0
; end of _chout
