#line 1 "C:/PIC/MikroC/PIC18/PIC18F47K42/PICmon8/PICmon8.c"
#line 39 "C:/PIC/MikroC/PIC18/PIC18F47K42/PICmon8/PICmon8.c"
void linein(char* pstring);
char getparams(char* tempstring);
void PrintHex(unsigned char i);
void PrintHexSp(unsigned char i);
void midi_off(void);


void cmdf(void);
void cmdo(void);
void cmdp(void);
void cmdr(void);
void cmdw(void);


char rxbuff[20];
char rxidx;
unsigned char newcmd;
unsigned char cmd;
unsigned char u1_rx_data;
unsigned char u1_rx_flag = 0;
unsigned char u2_rx_data;
unsigned char u2_rx_flag = 0;
unsigned char linebuff[120];
unsigned char param[8][20];
unsigned int upar[8];
unsigned char nparams;
unsigned char int_rx_buf[4];
unsigned char EC_hdr;
unsigned char EC_tmp;
unsigned int EC_adr;
unsigned char EC_data;
unsigned char e_send[2];
unsigned int ee_addr;

void interrupt() {
 if(U2RXIF_bit) {
 u2_rx_data = UART2_Read();
 ByteToHex(u2_rx_data, int_rx_buf);
 u2_rx_flag = 1;
 }
}

void main() {
 rxidx = 0;
 ANSELA = 0;
 ANSELB = 0;
 ANSELC = 0;
 ANSELD = 0;
 TRISA = 0;
 TRISB = 0;
 TRISC = 0;
 TRISD = 0;
 LATA = 0;
 LATB = 0x00;
 LATC = 0x00;
 LATD = 0x00;


 UART2_Init(31250);
 UART1_Init(115200);
 Delay_ms(100);
 newcmd = '?';
 cmd = newcmd;

 UART1_Write_Text("\r\n\nPICmon8 Monitor 2 Sept 2019\r\n");
 UART1_Write_Text("? for help\r\n");

 U2RXIE_bit = 1;
 U2RXIF_bit = 0;
 GIE_bit = 1;

 while(1){
 linein(linebuff);
 newcmd = getparams(linebuff);
 switch(newcmd){
 case 'F':
 cmdf();
 break;

 case 'O':
 cmdo();
 break;

 case 'P':
 cmdp();
 break;

 case 'R':
 cmdr();
 break;

 case 'W':
 cmdw();
 break;

 case '?':
 UART1_Write_Text("?        List Commands\r\n");
 UART1_Write_Text("f dd     Fill with dd EEPROM Click mikroBUS1\r\n");
 UART1_Write_Text("o cc ..  Output hex to MIDI\r\n");
 UART1_Write_Text("p        Parameter test\r\n");
 UART1_Write_Text("r        Read EEPROM Click mikroBUS1\r\n");
 UART1_Write_Text("w aaa dd Write EEPROM Click mikroBUS1\r\n");
 break;

 default:{
 UART1_Write_Text("\r\ncommand not recognised\r\n");
 break;
 }
 }
 }
}



void cmdf(){

 e_send[1] = upar[1];

 LATC0_bit = 0;
 ANSELC0_bit = 0;
 TRISC0_bit = 0;
 UART1_Write_Text("\r\nEEPROM Fill.");

 I2C1_Init();

 Delay_ms(100);

 if(nparams == 2){
 for(ee_addr = 0; ee_addr < 1024; ee_addr++){
 EC_tmp = (ee_addr >> 8) & 0x03;
 EC_hdr = 0x50 + EC_tmp;
 e_send[0]= ee_addr & 0x0ff;
 I2C1_Wr(EC_hdr, &e_send, 2, _I2C_END_MODE_STOP);
 Delay_ms(5);
 if((ee_addr & 0x1f) == 0){
 UART1_Write_Text(".");
 }
 }
 }
 else{
 UART1_Write_Text("syntax error - need...\r\nf dd\r\n");
 }
 LATC0_bit = 1;
 UART1_Write_Text("\r\ndone\r\n");
}



void cmdo(){
unsigned char pc;

 UART1_Write_Text("MIDI out ");
 for(pc = 1; pc < nparams; pc++){
 UART2_Write(upar[pc]);
 PrintHexSp(upar[pc]);
 }
 UART1_Write_Text("\r\n");
}

void cmdp(){
 unsigned char paramcount;
 PrintHex(nparams);
 UART1_Write_Text(" parameters\r\n");
 Delay_ms(100);
 for( paramcount = 0 ; paramcount < 8 ; paramcount++ ){
 UART1_Write_Text("parameter ");
 PrintHexSp(paramcount);
 PrintHex((upar[paramcount] >> 8) & 0xff);
 PrintHex((upar[paramcount]) & 0xff);
 UART1_Write_Text("\r\n");
 }
}


void cmdr(){

 LATC0_bit = 1;
 ANSELC0_bit = 0;
 TRISC0_bit = 0;
 UART1_Write_Text("\r\nEEPROM Contents...");

 I2C1_Init();
 Delay_ms(100);

 for(EC_adr = 0; EC_adr < 1024; EC_adr++){
 if(! (EC_adr & 0x0f)){
 UART1_Write_Text("\r\n");
 PrintHex(EC_adr/256);
 PrintHex(EC_adr);
 UART1_Write_Text(" = ");
 }
 else{
 if(! (EC_adr & 0x03)){
 UART1_Write_Text("- ");
 }
 }
 EC_tmp = (EC_adr >> 8) & 0x03;
 EC_hdr = 0x50 + EC_tmp;
 I2C1_Wr(EC_hdr, &EC_adr, 1, _I2C_END_MODE_RESTART);
 I2C1_Rd(EC_hdr, &EC_data, 1, _I2C_END_MODE_STOP);
 PrintHexSp(EC_data);
 Delay_ms(1);
 }
 UART1_Write_Text("\r\n");
}



void cmdw(){

 e_send[0] = upar[1];
 e_send[1] = upar[2];

 LATC0_bit = 0;
 ANSELC0_bit = 0;
 TRISC0_bit = 0;
 UART1_Write_Text("\r\nEEPROM Write...");

 I2C1_Init();

 Delay_ms(100);

 if(nparams == 3){
 EC_tmp = (upar[1] + 3) & 0x03;
 EC_hdr = 0x50 + EC_tmp;
 I2C1_Wr(EC_hdr, &e_send, 2, _I2C_END_MODE_STOP);

 }
 else{
 UART1_Write_Text("syntax error - need...\r\nw aaa dd\r\n");
 }
 LATC0_bit = 1;
 UART1_Write_Text("\r\n");
}


void PrintHex(unsigned char i) {
unsigned char hi,lo;

 hi = i & 0xF0;
 hi = hi >> 4;
 hi = hi + '0';
 if (hi > '9') hi = hi + 7;
 lo = (i & 0x0F) + '0';
 if (lo>'9') lo=lo+7;

 UART1_Write(hi);
 UART1_Write(lo);
}


void PrintHexSp(unsigned char i) {
unsigned char hi,lo;

 hi = i & 0xF0;
 hi = hi >> 4;
 hi = hi + '0';
 if (hi > '9') hi = hi + 7;
 lo = (i & 0x0F) + '0';
 if (lo>'9') lo=lo+7;

 UART1_Write(hi);
 UART1_Write(lo);
 UART1_Write(' ');
}


char getparams(char* tempstring){
char oldcmd;
int n;
char tempchar;
char tempchar2;
unsigned int pointer1=0;
unsigned int pointer2=0;

 oldcmd=cmd;
 nparams = 0;
 pointer1 = 0;

 for ( n = 0 ; n < 8 ; n++){

 tempchar=1;
 do {
 tempchar = tempstring[pointer1++];
 } while (tempchar == 0x20);
 pointer1--;


 if ((tempchar != 0) && (nparams < 8)){
 nparams++;
 }

 if (n == 0){
 tempchar=tempstring[pointer1];
 if ((tempchar > 0x60) && (tempchar < 0x7b)) {
 tempchar -= 0x20;
 }
 cmd=tempchar;
 }

 tempchar=1;
 if (nparams != 0){

 pointer2=0;
 do {
 tempchar = tempstring[pointer1++];
 if ((tempchar > 0x60) && (tempchar < 0x7b)) {
 tempchar -= 0x20;
 }
 param[n][pointer2++] = tempchar;
 } while ((tempchar > 0x20) && (tempchar < 0x7f) && (pointer2 < 20));
 param[n][pointer2-1]=0;
 if((tempchar == 0)||(n == 9)){
 break;
 }
 }
 }


 for (n = 0; n < nparams ; n++){
 tempchar2=1;
 pointer1=0;
 upar[n]=0;
 do {
 tempchar = param[n][pointer1++];

 if ( tempchar != 0 ){
 upar[n] = upar[n] * 0x10;
 } tempchar2=tempchar;

 if ((tempchar < 0x30) || (tempchar > 0x46)) {
 tempchar = 0x00;
 }
 if ((tempchar > 0x39) && (tempchar < 0x41)) {
 tempchar = 0x00;
 }
 if ((tempchar > 0x40) && (tempchar < 0x47)) {
 tempchar -= 0x37;
 }
 if ((tempchar > 0x2f) && (tempchar < 0x3a)) {
 tempchar -= 0x30;
 }
 upar[n] += tempchar;
 } while (tempchar2 != 0);
 }

 if (nparams == 0) {
 cmd = oldcmd;
 }
 return cmd;
}





void linein(char* pstring){
char inChar = 0;

 while(inChar != '\r'){


 if (UART1_Data_Ready()){
 inChar = UART1_Read();
 UART1_Write(inChar);
 if(inChar == '\r'){
 UART1_Write('\n');
 *pstring ++= '\0';
 }
 else {
 if (inChar != 0x7f ){
 *pstring++ = inChar;
 }
 if (inChar == 0x7f ){
 *--pstring = 0x00;
 }
 }
 }
 if(u2_rx_flag){
 u2_rx_flag = 0;
 if(u2_rx_data > 127){
 UART1_Write_Text("\r\n");
 UART1_Write_Text(int_rx_buf);
 }
 else{
 UART1_Write_Text("-");
 UART1_Write_Text(int_rx_buf);
 }
 }
 }
}


char chin(void){
char temp;

 while(!UART1_Data_Ready());
 temp = UART1_Read();
 return temp;
}


void chout(char outchar){

 UART1_Write(outchar);
 if(outchar == 0x0d){
 UART1_Write(0x0a);
 }
}
