// simple UART test for EasyPIC 8
//   PIC18F47K42 32 MHz
//     - Turn on RX and TX UART switches (SW21.8 and SW23.8)
// note that UART pins are remappable, but default UART1 pins are used here (RC6 Tx, RC7 Rx)

char uart_rd;

void main() {
    ANSELC = 0;                                            // Configure PORTC pins as digital

    UART1_Init(115200);
    Delay_ms(100);                                         // Wait for UART module to stabilize
    UART1_Write_Text("Start 15 Aug 2019\r\n");

    while (1) {                                            // Endless loop
        if (UART1_Data_Ready()) {               // If data is received,
            uart_rd = UART1_Read();             // read the received data,
            UART1_Write(uart_rd);               // and send data via UART
        }
        UART1_Write_Text("Hello\r\n");
        Delay_ms(1000);
    }
}