//  Simple code to test UART I/O using PPS remapping
// EasyPIC8 board with PIC18F47K42 at 32 MHZ
// written using the trial-and-error method - don't fully understand

// status as at 29 Aug 2019 ...
// no luck with returning Tx mapped pins back to I/O pins


unsigned char UART_input;                                                       // just a temporary store

void main() {

    ANSELA = 0;                                                                 // let's keep life simple and make all digital
    ANSELB = 0;                                                                 // all digital   - Rx will not work if analogue
    ANSELC = 0;                                                                 // all digital
    ANSELD = 0;                                                                 // all digital
    ANSELE = 0;                                                                 // all digital

    // it seems to be that UART init must be done before PPS mapping - don't know why
    UART1_Init(9600);                                                           // remappable init seems to give strange compile error
    Delay_ms(100);                                                              // UART settle time

    Unlock_IOLOCK();
    PPS_Mapping_NoLock(9, _INPUT, _RX1);                                        // map UART1 Rx to B1 (only ports B and C are valid for U1Rx)
    PPS_Mapping_NoLock(10, _OUTPUT, _TX1PPS);                                   // map UART1 Tx to B2
    Delay_ms(200);                                                              // settle time


    UART1_Remappable_Write_Text("\r\nUART1 RB2=Tx, RB1=Rx - type to continue..\r\n");
    while(!UART1_Remappable_Data_Ready());                                                 // wait for data to become available
    UART_input = UART1_Remappable_Read();                                                  // fetch a single byte
    UART1_Remappable_Write_Text("OK\r\n");


    UART1_Remappable_Write_Text("End Program\r\n");

    while(1);                                                                   // infinite loop - not strictly necessary for mikroC
}