// simple test of Vref on RA0 of MikroE EasyPIC v8
// raw ADC values only - converting to voltage cannot be guaranteed, so I deliberately avoid it
// 16x2 LCD fitted to EasyPIC v8 board, Vref switch RA0 on, 8 MHz crystal with 4xPLL for 32MHz clock
// provide pull down on RA3, RB1, RB2, RB3, RB4, RB5 - makes external oscillator startup reliable
// run codegrip program to adjust Vref on EasyPIV v8
// make sure that PORTA leds are disabled, or result may be inaccurate

// status 15 Sept 2019:
// no obvous problems known at this time - other than lack of information on how Vref and ADC libraries work

// Lcd module connections
sbit LCD_RS at LATA3_bit;
sbit LCD_EN at LATB1_bit;                                                       // be sure to put pull-downs on these port pins...
sbit LCD_D4 at LATB2_bit;                                                       //  ... if using EasyPIC v8 with 16x2 fitted ...
sbit LCD_D5 at LATB3_bit;                                                       //  ... else 8MHz osc may not start reliably
sbit LCD_D6 at LATB4_bit;
sbit LCD_D7 at LATB5_bit;
sbit LCD_RS_Direction at TRISA3_bit;
sbit LCD_EN_Direction at TRISB1_bit;
sbit LCD_D4_Direction at TRISB2_bit;
sbit LCD_D5_Direction at TRISB3_bit;
sbit LCD_D6_Direction at TRISB4_bit;
sbit LCD_D7_Direction at TRISB5_bit;
// End Lcd module connections

// global variables
unsigned int current_adc;
unsigned char conv_text[10];                                                    // general purpose conversion text buffer

void main() {
    ANSELC = 0;                                                                 // all digital
    TRISC = 0;                                                                  // all output
    LATC = 0;                                                                   // all low (RC2 low for LCD backlight on

    Lcd_Init();
    LCD_Out(1,1,"Vref on RA0     ");
    LCD_Out(2,1,"                ");

    while(1){
        current_adc = ADC_Read(0);
        WordToStrWithZeros(current_adc, conv_text);
        Lcd_Out(2,1,conv_text);
        Lcd_Out(2,6," of 4095");
        Delay_ms(1000);                                                         // limit display update rate
    }
}