#line 1 "C:/PIC/MikroC/PIC18/PIC18F47K42/click/GNSS5_MB1_LCD/GNSS5.c"
#line 49 "C:/PIC/MikroC/PIC18/PIC18F47K42/click/GNSS5_MB1_LCD/GNSS5.c"
sbit LCD_RS at LATA3_bit;
sbit LCD_EN at LATB1_bit;
sbit LCD_D4 at LATB2_bit;
sbit LCD_D5 at LATB3_bit;
sbit LCD_D6 at LATB4_bit;
sbit LCD_D7 at LATB5_bit;
sbit LCD_RS_Direction at TRISA3_bit;
sbit LCD_EN_Direction at TRISB1_bit;
sbit LCD_D4_Direction at TRISB2_bit;
sbit LCD_D5_Direction at TRISB3_bit;
sbit LCD_D6_Direction at TRISB4_bit;
sbit LCD_D7_Direction at TRISB5_bit;



void linein(char* pstring);
char getparams(char* tempstring);
void PrintHex(unsigned char i);
void PrintHexSp(unsigned char i);
void get_field(unsigned char buffernum, unsigned char fieldnum);


void cmdm(void);
void cmdo(void);
void cmdp(void);
void cmds(void);
void cmdt(void);
void cmdv(void);


unsigned char GNGLL_ptr;
unsigned char GNGLL_flag;
unsigned char GNRMC_ptr;
unsigned char GNRMC_flag;
unsigned char GNVTG_ptr;
unsigned char GNVTG_flag;
unsigned char GNGGA_ptr;
unsigned char GNGGA_flag;
unsigned char buff_num;
unsigned char gnsspointer;
unsigned char gnssbuff[16][256];
unsigned char rxidx;
unsigned char newcmd;
unsigned char cmd;
unsigned char u1_rx_data;
unsigned char u1_rx_flag = 0;
unsigned char u2_rx_data;
unsigned char u2_rx_flag = 0;
unsigned char linebuff[120];
unsigned char param[8][20];
unsigned int upar[8];
unsigned char nparams;
unsigned char int_rx_buf[4];
unsigned char EC_hdr;
unsigned char EC_tmp;
unsigned int EC_adr;
unsigned char EC_data;
unsigned char e_send[2];
unsigned int ee_addr;
unsigned char gprint_flag;
unsigned char t_flag;
unsigned char time_text[20];
unsigned char sat_text[2];
unsigned char field_text[40];

void interrupt() {
 if(U1RXIF_bit) {
 u1_rx_data = UART1_Read();
 int_rx_buf[0] = u1_rx_data;
 int_rx_buf[1] = 0;
 if(int_rx_buf[0] == '$'){
 if( gnssbuff[buff_num][1] == 'G'){
 if( gnssbuff[buff_num][5] == 'A'){
 if(gnssbuff[buff_num][4] == 'G'){
 GNGGA_ptr = buff_num;
 LATA2_bit ^= 1;
 GNGGA_flag = 1;
 }
 }
 if( gnssbuff[buff_num][5] == 'C'){
 GNRMC_ptr = buff_num;
 LATA0_bit ^= 1;
 GNRMC_flag = 1;
 }
 if( gnssbuff[buff_num][5] == 'G'){
 GNVTG_ptr = buff_num;
 LATA4_bit ^= 1;
 GNVTG_flag = 1;
 }
 if( gnssbuff[buff_num][5] == 'L'){
 GNGLL_ptr = buff_num;
 LATA5_bit ^= 1;
 GNGLL_flag = 1;
 }
 }
 gnsspointer = 0;
 buff_num++;
 }
 buff_num &= 0x0f;
 gnssbuff[buff_num][gnsspointer] = int_rx_buf[0];
 gnsspointer++;
 u1_rx_flag = 1;
 }
}

void main() {
 Lcd_Init();
 Delay_ms(100);
 Lcd_Out(1,1,"GNSS     nSAT   ");
 ANSELE = 0;
 TRISE = 0x01;
 if(RE0_bit){
 Lcd_Out(1,1,"Terminal D6 D7  ");
 Lcd_Out(2,1,"RE0 low for LCD ");
 }
 rxidx = 0;
 ANSELA = 0;
 ANSELB = 0;
 ANSELC = 0;
 ANSELD = 0;
 TRISA = 0x00;
 TRISB = 0x01;
 TRISC = 0x80;
 TRISD = 0x80;
 LATA = 0x04;
 LATB = 0x00;
 LATC = 0x00;
 LATD = 0x00;
 LATE = 0x02;


 UART1_Init(9600);

 if(RE0_bit){

 UART2_Init(115200);
 }


 Unlock_IOLOCK();
 PPS_Mapping_NoLock(0x1f, _INPUT, _RX2);
 PPS_Mapping_NoLock(0x1e, _OUTPUT, _TX2PPS);
 Delay_ms(100);

 gprint_flag = 0;
 t_flag = 1;
 newcmd = '?';
 cmd = newcmd;
 gnsspointer = 0;

 UART2_Write_Text("\r\n\nGNSS Monitor 11 Sept 2019\r\n");
 UART2_Write_Text("? for help\r\n");


 U1RXIE_bit = 1;
 U1RXIF_bit = 0;
 GIE_bit = 1;

 GNGLL_ptr = 0xff;
 GNRMC_ptr = 0xff;
 GNVTG_ptr = 0xff;
 buff_num = 0;

 while(1){
 linein(linebuff);
 newcmd = getparams(linebuff);
 switch(newcmd){
 case 'M':
 cmdm();
 break;

 case 'O':
 cmdo();
 break;

 case 'P':
 cmdp();
 break;

 case 'S':
 cmds();
 break;

 case 'V':
 cmdv();
 break;

 case '?':
 UART2_Write_Text("?        List Commands\r\n");
 UART2_Write_Text("m        message buffer print\r\n");
 UART2_Write_Text("o cc ..  Output hex to GNSS5\r\n");

 UART2_Write_Text("s        sync LED indicators\r\n");
 UART2_Write_Text("t        toggle Time display on/off\r\n");
 UART2_Write_Text("v        toggle View raw GNSS text\r\n");
 break;

 default:{
 UART2_Write_Text("\r\ncommand not recognised\r\n");
 break;
 }
 }
 }
}


void cmdm(){
 unsigned char b_num;
 unsigned char b_ptr;
 unsigned char b_chc;
 unsigned char b_flag;
 unsigned char b_count;

 GNGLL_flag = 0;
 while(!GNGLL_flag);

 UART2_Write_Text("\r\nNewest buffer is 0x");
 PrintHexSp(buff_num);
 UART2_Write_Text("   (Oldest buffer shown first)");
 b_num = buff_num;

 for(b_count = 0; b_count < 16; b_count++){
 b_num++;
 if(b_num > 15) b_num = 0;
 UART2_Write_Text("\r\n\nBuffer 0x");
 PrintHexSp(b_num);
 b_flag = 1;
 for( b_ptr = 0; b_ptr < 255; b_ptr++){
 if(b_flag){
 b_chc = GNSSbuff[b_num][b_ptr];
 UART2_Write(b_chc);
 if(b_chc == 0x0d){
 b_flag = 0;
 }
 }
 }
 }
 UART2_Write_Text("\r\n\n");
}



void cmdo(){
unsigned char pc;

 UART2_Write_Text("GNSS out ");
 for(pc = 1; pc < nparams; pc++){
 UART1_Write(upar[pc]);
 PrintHexSp(upar[pc]);
 }
 UART2_Write_Text("\r\n");
}


void cmdp(){
 unsigned char paramcount;
 PrintHex(nparams);
 UART2_Write_Text(" parameters\r\n");
 Delay_ms(100);
 for( paramcount = 0 ; paramcount < 8 ; paramcount++ ){
 UART2_Write_Text("parameter ");
 PrintHexSp(paramcount);
 PrintHex((upar[paramcount] >> 8) & 0xff);
 PrintHex((upar[paramcount]) & 0xff);
 UART2_Write_Text("\r\n");
 }
}


void cmds(){
 while(!RB0_bit);
 LATA = 0;
}


void cmdt(){
 t_flag ^= 1;
}


void cmdv(){

 gprint_flag ^= 1;
}


void PrintHex(unsigned char i) {
unsigned char hi,lo;

 hi = i & 0xF0;
 hi = hi >> 4;
 hi = hi + '0';
 if (hi > '9') hi = hi + 7;
 lo = (i & 0x0F) + '0';
 if (lo>'9') lo=lo+7;

 UART2_Write(hi);
 UART2_Write(lo);
}


void PrintHexSp(unsigned char i) {
unsigned char hi,lo;

 hi = i & 0xF0;
 hi = hi >> 4;
 hi = hi + '0';
 if (hi > '9') hi = hi + 7;
 lo = (i & 0x0F) + '0';
 if (lo>'9') lo=lo+7;

 UART2_Write(hi);
 UART2_Write(lo);
 UART2_Write(' ');
}


char getparams(char* tempstring){
char oldcmd;
int n;
char tempchar;
char tempchar2;
unsigned int pointer1=0;
unsigned int pointer2=0;

 oldcmd=cmd;
 nparams = 0;
 pointer1 = 0;

 for ( n = 0 ; n < 8 ; n++){

 tempchar=1;
 do {
 tempchar = tempstring[pointer1++];
 } while (tempchar == 0x20);
 pointer1--;


 if ((tempchar != 0) && (nparams < 8)){
 nparams++;
 }

 if (n == 0){
 tempchar=tempstring[pointer1];
 if ((tempchar > 0x60) && (tempchar < 0x7b)) {
 tempchar -= 0x20;
 }
 cmd=tempchar;
 }

 tempchar=1;
 if (nparams != 0){

 pointer2=0;
 do {
 tempchar = tempstring[pointer1++];
 if ((tempchar > 0x60) && (tempchar < 0x7b)) {
 tempchar -= 0x20;
 }
 param[n][pointer2++] = tempchar;
 } while ((tempchar > 0x20) && (tempchar < 0x7f) && (pointer2 < 20));
 param[n][pointer2-1]=0;
 if((tempchar == 0)||(n == 9)){
 break;
 }
 }
 }


 for (n = 0; n < nparams ; n++){
 tempchar2=1;
 pointer1=0;
 upar[n]=0;
 do {
 tempchar = param[n][pointer1++];

 if ( tempchar != 0 ){
 upar[n] = upar[n] * 0x10;
 }
 tempchar2=tempchar;
 if ((tempchar < 0x30) || (tempchar > 0x46)) {
 tempchar = 0x00;
 }
 if ((tempchar > 0x39) && (tempchar < 0x41)) {
 tempchar = 0x00;
 }
 if ((tempchar > 0x40) && (tempchar < 0x47)) {
 tempchar -= 0x37;
 }
 if ((tempchar > 0x2f) && (tempchar < 0x3a)) {
 tempchar -= 0x30;
 }
 upar[n] += tempchar;
 } while (tempchar2 != 0);
 }

 if (nparams == 0) {
 cmd = oldcmd;
 }
 return cmd;
}




void linein(char* pstring){
char inChar = 0;
unsigned char tpnt;
unsigned char b_num;

 while(inChar != '\r'){


 if (UART2_Data_Ready()){
 inChar = UART2_Read();
 UART2_Write(inChar);
 if(inChar == '\r'){
 UART2_Write('\n');
 *pstring ++= '\0';
 }
 else {
 if (inChar != 0x7f ){
 *pstring++ = inChar;
 }
 if (inChar == 0x7f ){
 *--pstring = 0x00;
 }
 }
 }
 if(u1_rx_flag){
 u1_rx_flag = 0;
 if(gprint_flag){
 UART2_Write_Text(int_rx_buf);
 }
 }
 if(GNGLL_flag){
 if(t_flag){
 if(!gprint_flag){
 UART2_Write_Text("\rUTC ");
 b_num = GNGLL_ptr;
 get_field(b_num, 6);
 UART2_Write_Text(field_text);
 Lcd_Out(2,1,"  UTC  ");
 Lcd_Out(2,8,field_text);

 UART2_Write_Text(" ");
 b_num = GNGLL_ptr;
 get_field(b_num, 7);
 UART2_Write_Text(field_text);
 Lcd_Out(2,1,field_text);

 UART2_Write_Text(" ");
 b_num = GNRMC_ptr;
 get_field(b_num, 10);
 UART2_Write_Text(field_text);
 Lcd_Out(1,1,field_text);

 UART2_Write_Text(" nSAT ");
 b_num = GNGGA_ptr;
 get_field(b_num, 8);
 UART2_Write_Text(field_text);
 UART2_Write_Text(" ");
 Lcd_Out(1,15,field_text);
 }
 }
 GNGLL_flag = 0;
 UART1_Write(0x12);
 }
 }
}


void get_field(unsigned char buffernum, unsigned char fieldnum){
 unsigned char b_pnt;
 unsigned char b_chr;
 unsigned char f_start;
 unsigned char f_end;
 unsigned char f_count;
 unsigned char f_pnt;
 unsigned char fs_flag;

 f_count = 0;
 f_start = 0;
 f_end = 0;
 f_pnt = 0;
 b_pnt = 0;
 fs_flag = 1;

 while(fs_flag){
 b_chr = gnssbuff[buffernum][b_pnt];
 field_text[f_pnt] = b_chr;
 if(b_chr == ','){
 f_end = b_pnt;
 field_text[f_pnt] = 0;
 f_count++;
 f_pnt = 0;
 if(f_count >= fieldnum) fs_flag = 0;
 }
 else{
 f_pnt++;
 if (f_pnt > 38){
 fs_flag = 0;
 field_text[0] = 0;
 }
 }
 b_pnt++;
 if (b_pnt == 255){
 fs_flag = 0;
 field_text[0] = 0;
 }
 }
}
